# Pupitre de cc6500
#
# History:
# 2019/02/24: Delmas-Begue Ulysse: adaptation du reseau pour s'interfcaer avec D17
#                                  configuration par defaut pour D17
# 2017/03/22: Delmas-Begue Ulysse: rajout du reseau pour s'interfacer avec fdcc2017
# 2016/12/19: Delmas-Begue Ulysse: rajout DCC et phares
# 2016/12/05: Delmas-Begue Ulysse: creation
#
# Notes:
# License: GPLv2
# Photo du pupitre: http://www.encabine.com
# This application works on Linux/Windows and Python3.x/2.x
#
# TBD
# - pente & vent?
# - sonds (+klaxon)

TITLE = "FDCC Pupitre CC6500 v20190226 UDB"

use_serial    = 0
SZ_SERIALPORT = "\\\\.\\COM4"

use_network   = 1
use_local     = 0
server_ip_adr = "192.168.4.1"
server_port   = 1234

# caracteristique (surement qq erreurs)
#
# type           | 6500
# nb             | 78 (CC 6501 a 6578) (les 4 dernieres sont les ex CC 21000)
# masse          | 120t
# vmax           | 200/100kmph puis 160/100kmph
# puissance      | 5900kW (1500V)
# freinage       | sabot et rheostatique (pas de recuperation) 25crans
# um             | non
# couplage       | serie    28crans+8shuntages
#                | serie // 28crans+8shuntages
#                | //       20crans+8shuntages
#

# pupitre:
#
# bargraphes
# VL | A M1 | A M3 | A FE | VBAT 30     + VBAT 72 a l'horizontal
# (VBAT30 utilise pour exiter le moteur en freinage si pb d'alimentation)
#
# pictos (si tout va bien , tout est eteint):
#  DJ  / 0 traction / PATINAGE / CB
#  PH1 / PH2        / PH3      / BAT
#  PH4 / PH5        / PH6      / FEP
#
# boite a boutons (il y a des supositions):
# DJ         | arm DJ     | compAUTO | compDirect | x       | chauff  | cpl serie  | fep      | x
# CVS        | ecl cabine | pupitre  | fanal G    | fanal D | projo G = projo D    | armVACMA | essVACMA

# parametres pwm pour commander une locomotive via carte Arduino
pwm_vit_max    = 200  # vitesse correspondante a pwm_max
pwm_max        = 255  # valeur de la pwm(0-255) a la vitesse max
pwm_min        = 1    # valeur de la pwm(0-255) pour demarrer la loco
pwm_inv_sens   = 0    # invertion du sens (0=ne pas inverser, 1=inverser)

# parametres dcc pour commander une locomotive via carte Arduino
dcc_adr        = 3    # adresse de la locomotive
dcc_vit_max    = 200  # vitesse correspondante a pwm_max
dcc_max        = 28   # valeur du cran DCC 0-28 a la vitesse max
dcc_min        = 1    # valeur du cran DCC 0-28 pour demarrer la loco
dcc_inv_sens   = 0    # invertion du sens (0=ne pas inverser, 1=inverser)
net_max        = 100  # valeur a envoyer par le reseau a la vitesse max (100 pour D17, 28 pour fdcc2017)
net_min        = 1    # valeur a envoyer par le reseau pour demarrer la loco

# parametres de simulation (a adapter suivant les besoins)
vmax              = 200.0   # kmph   GV 200kmph puis 160kmph / PV 100kmph
t_0_100_mot       = 10.0    # s
t_100_0_fr        = 5.0     # s
t_100_0_frd       = 10.0    # s frein direct
t_100_0_frrh      = 15.0    # s frein rheostatique
t_100_0_erre      = 30.0    # s
t_press_3b5_5b    = 4.0     # s
t_press_au_5b_3b5 = 1.0     # s
t_press_0b_5b_fd  = 3.0     # s

# a l'init
vit = 0.0                  # kmph (a l'init)
pression_rp_0_10  = 8.0    # bars (a l'init mais bouge pas)
pression_cg_0_5   = 0.0    # bars (a l'init)
pression_cfd_0_5  = 0.0    # bars (a l'init) frein direct
pression_cf_0_5   = 5.0    # bars (a l'init)
robinet_au = 0             # 0=ferme, 1=ouvert donc AU


SERIE       = 1
SERIE_PARA  = 2
PARA        = 3
couplage        = SERIE_PARA
shuntage        = 0
cran            = 0
cran_fr         = 0

PANTO_RETIRE = 0
PANTO_0      = 1
PANTO_AV     = 2
PANTO_AVAR   = 3
PANTO_AR     = 4
panto            = PANTO_RETIRE
dj_on            = 0

RETIRE   = 0
RETRAIT  = 1
ISO      = 2
NEUTRE   = 3
SERVICE  = 4
palette_service = RETIRE

RETIRE  = 0 #redefine
CLE_OFF = 1
CLE_ON  = 2
cle = RETIRE

RETIRE = 0 #redefine
AV     = 2
ARRET  = 3
AR     = 4
palette_sens = RETIRE
mem_sens = AV

CERCLO_PR      = 0
CERCLO_PLUS    = 1
CERCLO_STOP    = 2
CERCLO_MOINS   = 3
CERCLO_0       = 4
CERCLO_P       = 5
CERCLO_FRMOINS = 6
CERCLO_FRSTOP  = 7
CERCLO_FRPLUS  = 8
CERCLO_FR      = 9
cerclo = CERCLO_0
old_cerclo = CERCLO_0

line_help = 0     # lignes d'aides (1=afficher en vert, 0=ne pas afficher)


# ecrasement de certains parametres(machine operationnelle directement)
#cle               = CLE_ON
#palette_sens      = ARRET
#palette_service   = SERVICE
#pression_cg_0_5   = 5.0
#pression_cf_0_5   = 0.0
#panto             = PANTO_AR
#dj_on             = 1


# autres variables sans besoin de modifications

btn_grand_debit = 0

DESS = 2
RIEN = 0
SERR = 1
manette_frein = RIEN
manette_freind= RIEN

KL_AV  = 1
KL_0   = 0
KL_AR  = 2
manette_klaxon = KL_0

LSSF_0   = 0
LSSF_1   = 1
LSSF_CLI = 2
lssf = LSSF_0
lssf_dcpt = LSSF_0



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# IMPORT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

import os
import time
import sys
import subprocess
import threading
import datetime
import socket
print("Hello \""+TITLE+"\"")
try:
    # for Python 3
    from tkinter import *
    print("INFO:  Python 3.x interpreter detected")
except ImportError:
    # for Python2
    from Tkinter import *
    print("INFO:  Python 2.x interpreter detected")
from math import *
PI = 3.14

ser = 0
serial_ok = 1
if(use_serial):
    try:
        import serial
    except ImportError:
        serial_ok = 0
        print("Cannot load serial lib")
else:
    serial_ok = 0



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# DRAW FCTs
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

# parametres du pupitre
fichier_pupitre = "cc6500.png"
img_pupitre = 0
img_dx = 0; img_dy = 0

x_aig_vit= 675; y_aig_vit= 100; d_aig_vit= 40; line_aig_vit=0;
x_aig_rp = 185; y_aig_rp = 170; d_aig_rp = 31; line_aig_rp=0;
x_aig_cg = 185; y_aig_cg = 170; d_aig_cg = 31; line_aig_cg=0;
x_aig_re = 256; y_aig_re = 147; d_aig_re = 21; line_aig_re=0
x_aig_cf = 313; y_aig_cf = 126; d_aig_cf = 21; line_aig_cf=0;

xc_boule_fr    = 174; yc_boule_fr     = 316
xdess_boule_fr = 164; ydess_boule_fr  = 260
x0_boule_fr    = 154; y0_boule_fr     = 290
xserr_boule_fr = 144 ; yserr_boule_fr = 320
b_fr  = 15
line_cmd_fr=0; oval_cmd_fr=0

xc_boule_frd    = 45; yc_boule_frd    = 375
xdess_boule_frd = 40; ydess_boule_frd = 270
x0_boule_frd    = 17; y0_boule_frd    = 300
xserr_boule_frd = -5; yserr_boule_frd = 330
line_cmd_frd=0; oval_cmd_frd=0

xc_sens   = 550; yc_sens   = 190
xav_sens  = 590; yav_sens  = 170
x0_sens   = 605; y0_sens   = 190
xarr_sens = 620; yarr_sens = 215
line_cmd_sens=0; oval_cmd_sens=0
x_txt_sens = 540; y_txt_sens = 203; txt_sens = 0

xc_srv = 200; yc_srv = 240; d_srv = 30; xoff_srv=8; b_srv = 15
line_cmd_srv=0; oval_cmd_srv=0;

xc_klaxon   = 820; yc_klaxon   = 295
xav_klaxon  = 850; yav_klaxon  = 210
x0_klaxon   = 870; y0_klaxon   = 240
xarr_klaxon = 890; yarr_klaxon = 270
line_cmd_klaxon=0; oval_cmd_klaxon=0

x_volt_ligne = 360 ;  y_volt0_ligne = 87; y_volt100_ligne = 44
x_amp_m1     = 390 ;  y_amp0_m1     = 87; y_amp100_m1     = 44; line_amp_m1 = 0
x_amp_m2     = 423 ;  y_amp0_m2     = 87; y_amp100_m2     = 44; line_amp_m2 = 0
x_amp_fr     = 453 ;  y_amp0_fr     = 87; y_amp100_fr     = 44
x_volt_bat   = 485 ;  y_volt0_bat   = 87; y_volt100_bat   = 44; line_volt_bat = 0
x_volt_bat72 = 567 ;  y_volt_bat72 = 146; x2_volt_bat72 = 564 ; y2_volt_bat72 = 162; line_volt_bat72 = 0

xc_au = 30; yc_au = 200; x_au  = 85; y_au  = 245; oval_au=0

xc_cle = 566; yc_cle = 443;
x0_cle = 610; y0_cle = 470
x1_cle = 566; y1_cle = 490
line_cmd_cle=0

x_lssf       = 213; y_lssf = 49; oval_lssf = 0
xc_ack_lssf  = 705; yc_ack_lssf  = 375;

xc_grand_debit = 111; yc_grand_debit = 347

xc_voy_alerte = 668; yc_voy_alerte = 246; alerte = 0; old_alerte = -1; oval_alerte = 0
xc_cmd_alerte = 708; yc_cmd_alerte = 247

xc_cerclo = 435; yc_cerclo = 275; d_cerclo = 185; dy_cerclo = 155; a_cerclo = -92.0
line_cmd_cerclo = 0; line_aff_cerclo = 0

xc_shunt = 550; yc_shunt = 280; d_shunt = 90; a_shunt = 15.0
line_shunt=0; line2_shunt=0; oval_shunt=0
x2_shunt = 0; y2_shunt = 0   #position de la boule mise a jour par draw_update

x_txt_cran = 558; y_txt_cran = 112; txt_cran = 0
x_txt_shunt = 554; y_txt_shunt = 251; txt_shunt = 0
x_txt_picto_dij  = 265; y_txt_picto_dij  = 50; txt_picto_dij  = 0; old_ind_dij  = -1; ind_dij  =0
x_txt_picto_zero = 280; y_txt_picto_zero = 47; txt_picto_zero = 0; old_ind_zero = -1; ind_zero = 0

y_haut_on  = 420
y_haut_off = 445
x_dij_on      = 325 ; rect_dij_on      = 0; dij_on      = 0; old_dij_on      =-1
x_dij_arm     = 345 ; rect_dij_arm     = 0; dij_arm     = 0; old_dij_arm     =-1
x_comp_auto   = 365 ; rect_comp_auto   = 0; comp_auto   = 0; old_comp_auto   =-1
x_comp_direct = 385 ; rect_comp_direct = 0; comp_direct = 0; old_comp_direct =-1
rien=0              ;
x_ligne_train = 425 ; rect_ligne_train = 0; ligne_train = 0; old_ligne_train =-1
x_serie       = 445 ; rect_serie       = 0; serie       = 0; old_serie       =-1
x_fep         = 465 ; rect_fep         = 0; fep         = 0; old_fep         =-1
rien=0              ;

y_bas_on  = 460
y_bas_off = 480
x_cvs       = 325; rect_cvs       = 0; cvs       = 0; old_cvs       = -1
x_cabine    = 345; rect_cabine    = 0; cabine    = 0; old_cabine    = -1;
x_pupitre   = 365; rect_pupitre   = 0; pupitre   = 0; old_pupitre   = -1
x_fanal_g   = 385; rect_fanal_g   = 0; fanal_g   = 0; old_fanal_g   = -1;
x_fanal_d   = 405; rect_fanal_d   = 0; fanal_d   = 0; old_fanal_d   = -1
x_projo_g   = 425; rect_projo_g   = 0; projo_g   = 0; old_projo_g   = -1
x_projo_d   = 445; rect_projo_d   = 0; projo_d   = 0; old_projo_d   = -1;
x_arm_vacma = 465; rect_arm_vacma = 0; arm_vacma = 0; old_arm_vacma = -1;
x_ess_vacma = 485; rect_ess_vacma = 0; ess_vacma = 0; old_ess_vacma = -1

if(dj_on):
    dij_on = 1

xc_panto = 899; yc_panto = 272; d_panto = 40; a_panto=-15.0
line_panto = 0; oval_panto = 0; txt_panto  = 0

zefont = ("Times New Roman", 6)
filename_pupitre = 0
dbg_txt = ""

#creation du pupitre (image, aiguilles, manettes)
def draw_first():
    global filename_pupitre   #necessaire car si local, image perdue a la sortie de la fonction
    global dbg_txt
    global line_aig_vit;
    global line_aig_rp; global line_aig_cg; global line_aig_cf; global line_aig_re
    global oval_au;
    global line_cmd_srv; global oval_cmd_srv; global line_cmd_cle
    global line_cmd_sens; global oval_cmd_sens
    global line_cmd_fr; global oval_cmd_fr
    global line_cmd_frd; global oval_cmd_frd
    global line_cmd_klaxon; global oval_cmd_klaxon
    global oval_lssf
    global line_volt_bat; global line_amp_m1; global line_amp_m2; global line_volt_ligne; global line_amp_fr; global line_volt_bat72
    global line_cmd_cerclo; global line_aff_cerclo
    global rect_fanal_d; global rect_fanal_g; global rect_projo_d; global rect_projo_g
    global txt_cran; global txt_shunt; global txt_sens
    global txt_picto_dij; global txt_picto_zero
    global line_shunt; global line2_shunt; global oval_shunt
    global line_panto; global oval_panto; global txt_panto
    global rect_dij_on; global rect_dij_arm; global rect_comp_auto; global rect_comp_direct
    global rect_ligne_train; global rect_serie; global rect_fep
    global rect_cvs; global rect_cabine; global rect_pupitre
    global rect_arm_vacma; global rect_ess_vacma;
    global oval_alerte

    # image pupitre
    #filename_pupitre = PhotoImage(file = image_du_pupitre)
    image_pupitre = my_canvas.create_image(0, 0, image=img_pupitre, anchor = "nw")

    # info txt
    dbg_txt = my_canvas.create_text(10, img_dy+10, text = "DBG: .............", fill = "#ff0000", anchor = "nw")

    # aiguilles
    line_aig_vit = my_canvas.create_line(0,0,0,0,width=3,fill="#ffffff")
    line_aig_rp  = my_canvas.create_line(0,0,0,0,width=2,fill="#ff0000")
    line_aig_cg  = my_canvas.create_line(0,0,0,0,width=2,fill="#ffffff")
    line_aig_cf  = my_canvas.create_line(0,0,0,0,width=2,fill="#ffffff")
    line_aig_re  = my_canvas.create_line(0,0,0,0,width=2,fill="#ffffff")

    # bargraphes
    line_volt_ligne = my_canvas.create_line(0,0,0,0,width=2,fill="#ff0000")
    line_amp_m1     = my_canvas.create_line(0,0,0,0,width=2,fill="#ff0000")
    line_amp_m2     = my_canvas.create_line(0,0,0,0,width=2,fill="#ff0000")
    line_amp_fr     = my_canvas.create_line(0,0,0,0,width=2,fill="#ff0000")
    line_volt_bat   = my_canvas.create_line(0,0,0,0,width=2,fill="#ff0000")
    line_volt_bat72 = my_canvas.create_line(x_volt_bat72,y_volt_bat72,x2_volt_bat72,y2_volt_bat72,width=2,fill="#ff0000")

    # avertisseur
    line_cmd_klaxon = my_canvas.create_line(0,0,0,0,width=7,fill="#444444")
    oval_cmd_klaxon = my_canvas.create_oval(0,0,0,0,fill = "#111111", outline = "black")
    if(line_help):
        my_canvas.create_line(x0_klaxon,y0_klaxon,xav_klaxon,yav_klaxon,width=1,fill="#00ff00")
        my_canvas.create_line(x0_klaxon,y0_klaxon,xarr_klaxon,yarr_klaxon,width=1,fill="#00ff00")

    # cerclo
    line_cmd_cerclo = my_canvas.create_line(0,0,0,0,width=12,fill="#666666")
    line_aff_cerclo = my_canvas.create_line(0,0,0,0,width=5,fill="#00ff00")
    txt_cran = my_canvas.create_text(x_txt_cran, y_txt_cran, text="", fill="#FF9040")
    txt_shunt = my_canvas.create_text(x_txt_shunt, y_txt_shunt, text="", fill="#ffffff")
    #font=("Times", 10, "bold") ("Purisa", 12) ("Times", 10, "bold")  ("Helvetica", 10, "bold italic")    ("Symbol", 8)
    #or zefont = ("Times", 10, "bold")    font=zefont

    # panto
    line_panto = my_canvas.create_line(0,0,0,0,width=8,fill="#888888")
    oval_panto = my_canvas.create_oval(0,0,0,0,fill = "#111111", outline = "black")
    txt_panto = my_canvas.create_text(xc_panto+40, yc_panto, text="x", fill="#ffffff")

    # manette de shuntage
    line_shunt  = my_canvas.create_line(0,0,0,0,width=8,fill="#888888")
    line2_shunt = my_canvas.create_line(0,0,0,0,width=8,fill="#888888")
    oval_shunt  = my_canvas.create_oval(0,0,0,0,fill = "#111111",outline = "black")

    # manette de freinage
    line_cmd_fr = my_canvas.create_line(0,0,0,0, width=7,fill="#888888")
    oval_cmd_fr = my_canvas.create_oval(0,0,0,0, fill = "#111111", outline = "black")
    if(line_help):
        my_canvas.create_line(x0_boule_fr,y0_boule_fr,xserr_boule_fr,yserr_boule_fr,width=1,fill="#00ff00")
        my_canvas.create_line(x0_boule_fr,y0_boule_fr,xdess_boule_fr,ydess_boule_fr,width=1,fill="#00ff00")

    # manette de freinage direct
    line_cmd_frd = my_canvas.create_line(0,0,0,0,width=15,fill="#888888")
    oval_cmd_frd = my_canvas.create_oval(0,0,0,0, fill = "#111111", outline = "black")
    if(line_help):
        my_canvas.create_line(x0_boule_frd,y0_boule_frd,xserr_boule_frd,yserr_boule_frd,width=1,fill="#00ff00")
        my_canvas.create_line(x0_boule_frd,y0_boule_frd,xdess_boule_frd,ydess_boule_frd,width=1,fill="#00ff00")

    # manette de sens
    if(line_help):
        my_canvas.create_line(x0_sens,y0_sens,xav_sens,yav_sens,width=1,fill="#00ff00")
        my_canvas.create_line(x0_sens,y0_sens,xarr_sens,yarr_sens,width=1,fill="#00ff00")
    else:
        my_canvas.create_line(x0_sens-5,y0_sens-5,x0_sens+5,y0_sens+5,width=1,fill="#00ff00")
    line_cmd_sens  = my_canvas.create_line(0,0,0,0,width=8,fill="#888888")
    oval_cmd_sens = my_canvas.create_oval(0,0,0,0, fill = "#111111", outline = "black")
    txt_sens = my_canvas.create_text(x_txt_sens, y_txt_sens, text="", fill="#ffffff")

    # manette de mise en service
    line_cmd_srv = my_canvas.create_line(0,0,0,0,width=7,fill="#888888", capstyle=ROUND)
    oval_cmd_srv = my_canvas.create_oval(0,0,0,0,fill="#111111")

    #cle
    line_cmd_cle = my_canvas.create_line(0,0,0,0,width=20,fill="#888888", capstyle=ROUND)

    # robinet d'arret d'urgence
    oval_au = my_canvas.create_oval(xc_au,yc_au,x_au,y_au,fill="#ff0000")

    # lssf
    oval_lssf = my_canvas.create_oval(x_lssf-12,y_lssf-12,x_lssf+12,y_lssf+12,fill="#ffdd00")

    # pictos
    txt_picto_dij  = my_canvas.create_text(x_txt_picto_dij , y_txt_picto_dij , text="", fill="#FF0000")
    txt_picto_zero = my_canvas.create_text(x_txt_picto_zero, y_txt_picto_zero, text="", fill="#FF0000")

    # boutons
    rect_dij_on      = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_dij_arm     = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_comp_auto   = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_comp_direct = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    #
    rect_ligne_train = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_serie       = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_fep         = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    #

    rect_cvs       = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_cabine    = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_pupitre   = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_fanal_g   = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_fanal_d   = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_projo_d   = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_projo_g   = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_arm_vacma = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)
    rect_ess_vacma = my_canvas.create_rectangle(0, 0, 0, 0, fill='#888888', outline='#000000', width=1)

    # alerte
    oval_alerte = my_canvas.create_oval(xc_voy_alerte-15,yc_voy_alerte-15,xc_voy_alerte+15,yc_voy_alerte+15, fill = "#ffffff", outline = "black")

    return


# valeurs
aig_val_vit_0_210 = 0.0
aig_val_rp_0_10 = 8.0
aig_val_re_0_10 = 0.0
aig_val_cg_0_10 = 0.0
aig_val_cf_0_10 = 5.0
aig_volt_ligne_0_1500 = 0.0
aig_amp_m1_0_1000 = 0.0
aig_amp_m2_0_1000 = 0.0
aig_amp_fr_0_1000 = 0.0
aig_volt_bat_0_100 = 0.0

draw_update_cpt = 0
old_aig_val_vit_0_210 = -1.0   #sauvegarde des valeurs entre 2 appels pour
old_aig_val_rp_0_10 = -1.0     #ne pas redessiner et ainsi gagner en performances
old_aig_val_re_0_10 = -1.0
old_aig_val_cg_0_10 = -1.0
old_aig_val_cf_0_10 = -1.0
old_robinet_au = -1
old_palette_sens = -1
old_palette_service=-1
old_manette_frein = -1
old_manette_freind= -1
old_cle = -1
old_manette_klaxon = -1
old_lssf = -1
old_a_cerclo = -1
old_aig_volt_ligne_0_1500 = -1.0
old_aig_volt_bat_0_100 = -1.0
old_aig_amp_m1_0_1000 = -1.0
old_aig_amp_m2_0_1000 = -1.0
old_aig_amp_fr_0_1000 = -1.0
old_a_shunt = -1.0
old_panto = -1

#mise a jour des aiguilles et position des manettes
def draw_update():
    global my_canvas
    global line_aig_vit;
    global line_aig_rp; global line_aig_cg; global line_aig_re; global line_aig_cf
    global line_cmd_fr; global oval_cmd_fr; global oval_au
    global line_cmd_frd; global oval_cmd_frd;
    global line_cmd_srv; global oval_cmd_srv; global line_cmd_cle
    global line_volt_bat; global line_amp_m1; global line_amp_m2; global line_volt_ligne; global line_amp_fr; global line_volt_bat72
    global old_aig_val_vit_0_210;
    global old_aig_val_rp_0_10; global old_aig_val_cg_0_10; global old_aig_val_cf_0_10; global old_aig_val_re_0_10
    global old_robinet_au;
    global old_palette_sens; global old_palette_service; global old_manette_frein; global old_manette_freind; global old_cle
    global old_manette_klaxon; global line_cmd_klaxon; global oval_cmd_klaxon
    global old_lssf
    global draw_update_cpt
    global line_cmd_cerclo; global line_aff_cerclo; global old_a_cerclo
    global old_aig_volt_ligne_0_1500; global old_aig_amp_m1_0_1000; global old_aig_amp_m2_0_1000; global old_aig_amp_fr_0_1000; global old_aig_volt_bat_0_100;
    global rect_fanal_d; global rect_fanal_g; global rect_projo_d; global rect_projo_g
    global old_dij_on; global old_dij_arm; global old_comp_auto; global old_comp_direct; global old_ligne_train; global old_serie; global old_fep
    global old_cvs; global old_cabine; global old_pupitre; global old_fanal_d; global old_fanal_g; global old_projo_d; global old_projo_g; global old_arm_vacma; global old_ess_vacma
    global line_shunt; global line2_shunt; global oval_shunt; global txt_shunt; global txt_sens
    global x2_shunt; global y2_shunt; global old_a_shunt
    global old_panto; global line_panto; global oval_panto; global txt_panto; global a_panto
    global rect_dij_on; global rect_dij_arm; global rect_comp_auto; global rect_comp_direct
    global rect_ligne_train; global rect_serie; global rect_fep
    global rect_cvs; global rect_cabine; global rect_pupitre
    global rect_arm_vacma; global rect_ess_vacma;
    global old_ind_dij; global old_ind_zero
    global oval_alerte; global old_alerte

    draw_update_cpt += 1

    # mise a jour des aiguilles
    if(aig_val_vit_0_210 != old_aig_val_vit_0_210):
        angle = 195.0 - (195.0-(-20.0))*(aig_val_vit_0_210/205.0)
        x = int( float(x_aig_vit) + float(d_aig_vit) * cos(radians(angle)) )
        y = int( float(y_aig_vit) - float(d_aig_vit) * sin(radians(angle)) )
        my_canvas.coords(line_aig_vit, x_aig_vit, y_aig_vit, x, y)
        old_aig_val_vit_0_210 = aig_val_vit_0_210

    if(aig_val_rp_0_10 != old_aig_val_rp_0_10):
        angle = 230.0 - (230.0-(-38.0))*(aig_val_rp_0_10/10.0)
        x = int( float(x_aig_rp) + float(d_aig_rp) * cos(radians(angle)) )
        y = int( float(y_aig_rp) - float(d_aig_rp) * sin(radians(angle)) )
        my_canvas.coords(line_aig_rp, x_aig_rp, y_aig_rp, x, y)
        old_aig_val_rp_0_10 = aig_val_rp_0_10

    if(aig_val_re_0_10 != old_aig_val_re_0_10):
        angle = 230.0 - (230.0-(-25.0))*(aig_val_re_0_10/10.0)
        x = int( float(x_aig_re) + float(d_aig_re) * cos(radians(angle)) )
        y = int( float(y_aig_re) - float(d_aig_re) * sin(radians(angle)) )
        my_canvas.coords(line_aig_re, x_aig_re, y_aig_re, x, y)
        old_aig_val_re_0_10 = aig_val_re_0_10

    if(aig_val_cg_0_10 != old_aig_val_cg_0_10):
        angle = 230.0 - (230.0-(-40.0))*(aig_val_cg_0_10/10.0)
        x = int( float(x_aig_cg) + float(d_aig_cg) * cos(radians(angle)) )
        y = int( float(y_aig_cg) - float(d_aig_cg) * sin(radians(angle)) )
        my_canvas.coords(line_aig_cg, x_aig_cg, y_aig_cg, x, y)
        old_aig_val_cg_0_10 = aig_val_cg_0_10

    if(aig_val_cf_0_10 != old_aig_val_cf_0_10):
        angle = 230.0 - (230.0-(-200.0))*(aig_val_cf_0_10/10.0)
        x = int( float(x_aig_cf) + float(d_aig_cf) * cos(radians(angle)) )
        y = int( float(y_aig_cf) - float(d_aig_cf) * sin(radians(angle)) )
        my_canvas.coords(line_aig_cf, x_aig_cf, y_aig_cf, x, y)
        old_aig_val_cf_0_10 = aig_val_cf_0_10

    # bargraphes
    if(aig_volt_ligne_0_1500 != old_aig_volt_ligne_0_1500):
        old_aig_volt_ligne_0_1500 = aig_volt_ligne_0_1500;
        x = x_volt_ligne
        y = y_volt0_ligne + int((aig_volt_ligne_0_1500 / 1500.0) * float(y_volt100_ligne - y_volt0_ligne))
        my_canvas.coords(line_volt_ligne,x,y,x+15,y);

    if(aig_amp_m1_0_1000 != old_aig_amp_m1_0_1000):
        old_aig_amp_m1_0_1000 = aig_amp_m1_0_1000;
        x = x_amp_m1
        y = y_amp0_m1 + int((aig_amp_m1_0_1000 / 1000.0) * float(y_amp100_m1 - y_amp0_m1))
        my_canvas.coords(line_amp_m1,x,y,x+15,y);

    if(aig_amp_m2_0_1000 != old_aig_amp_m2_0_1000):
        old_aig_amp_m2_0_1000 = aig_amp_m2_0_1000;
        x = x_amp_m2
        y = y_amp0_m2 + int((aig_amp_m2_0_1000 / 1000.0) * float(y_amp100_m2 - y_amp0_m2))
        my_canvas.coords(line_amp_m2,x,y,x+15,y);

    if(aig_amp_fr_0_1000 != old_aig_amp_fr_0_1000):
        old_aig_amp_fr_0_1000 = aig_amp_fr_0_1000;
        x = x_amp_fr
        y = y_amp0_fr + int((aig_amp_fr_0_1000 / 1000.0) * float(y_amp100_fr - y_amp0_fr))
        my_canvas.coords(line_amp_fr,x,y,x+15,y);

    if(aig_volt_bat_0_100 != old_aig_volt_bat_0_100):
        old_aig_volt_bat_0_100 = aig_volt_bat_0_100;
        x = x_volt_bat
        y = y_volt0_bat + int((aig_volt_bat_0_100 / 100.0) * float(y_volt100_bat - y_volt0_bat))
        my_canvas.coords(line_volt_bat,x,y,x+15,y);

    # robinet AU
    if(robinet_au != old_robinet_au):
        old_robinet_au = robinet_au
        if(robinet_au==0):
            my_canvas.itemconfigure(oval_au,state=HIDDEN)
        else:
            my_canvas.itemconfigure(oval_au,state=NORMAL)

    # alerte
    if(old_alerte != alerte):
        old_alerte = alerte
        if(old_alerte==0):
            my_canvas.itemconfigure(oval_alerte,state=HIDDEN)
        else:
            my_canvas.itemconfigure(oval_alerte,state=NORMAL)

    # selecteur frein (service)
    if(palette_service != old_palette_service):
        old_palette_service = palette_service
        if(palette_service == RETIRE):
            my_canvas.itemconfigure(line_cmd_srv,state=HIDDEN)
            my_canvas.itemconfigure(oval_cmd_srv,state=HIDDEN)
        else:
            my_canvas.itemconfigure(line_cmd_srv,state=NORMAL)
            my_canvas.itemconfigure(oval_cmd_srv,state=NORMAL)

        if(palette_service == RETRAIT):
            my_canvas.coords(line_cmd_srv, xc_srv+5, yc_srv-d_srv/5, xc_srv-xoff_srv, yc_srv+d_srv)
            my_canvas.coords(oval_cmd_srv, xc_srv-b_srv-xoff_srv, yc_srv+d_srv-b_srv, xc_srv+b_srv-xoff_srv, yc_srv+d_srv+b_srv)
        if(palette_service == SERVICE):
            my_canvas.coords(line_cmd_srv, xc_srv-5, yc_srv+d_srv/5, xc_srv+xoff_srv, yc_srv-d_srv)
            my_canvas.coords(oval_cmd_srv, xc_srv-b_srv+xoff_srv, yc_srv-d_srv-b_srv, xc_srv+b_srv+xoff_srv, yc_srv-d_srv+b_srv)
        if(palette_service == ISO):
            my_canvas.coords(line_cmd_srv, xc_srv-d_srv/5, yc_srv, xc_srv+d_srv, yc_srv)
            my_canvas.coords(oval_cmd_srv, xc_srv+d_srv-b_srv, yc_srv-b_srv, xc_srv+d_srv+b_srv, yc_srv+b_srv)
        if(palette_service == NEUTRE):
            my_canvas.coords(line_cmd_srv, xc_srv+d_srv/5, yc_srv, xc_srv-d_srv, yc_srv)
            my_canvas.coords(oval_cmd_srv, xc_srv-d_srv-b_srv, yc_srv-b_srv, xc_srv-d_srv+b_srv, yc_srv+b_srv)

    # palette sens
    if(palette_sens != old_palette_sens):
        old_palette_sens = palette_sens
        txt = " "
        if(palette_sens == RETIRE):
            my_canvas.itemconfigure(line_cmd_sens,state=HIDDEN)
            my_canvas.itemconfigure(oval_cmd_sens,state=HIDDEN)
        else:
            my_canvas.itemconfigure(line_cmd_sens,state=NORMAL)
            my_canvas.itemconfigure(oval_cmd_sens,state=NORMAL)

        if(palette_sens == AV):
            my_canvas.coords(line_cmd_sens, xc_sens, yc_sens, xc_sens+15, yc_sens-5)
            my_canvas.coords(oval_cmd_sens, xav_sens-15, yav_sens-15, xav_sens+15, yav_sens+15)
            txt = "AV"
        if(palette_sens == ARRET):
            my_canvas.coords(line_cmd_sens, xc_sens, yc_sens, xc_sens+20, yc_sens)
            my_canvas.coords(oval_cmd_sens, x0_sens-15, y0_sens-15, x0_sens+15, y0_sens+15)
            txt = "0"
        if(palette_sens == AR):
            my_canvas.coords(line_cmd_sens, xc_sens, yc_sens, xc_sens+30, yc_sens+15)
            my_canvas.coords(oval_cmd_sens, xarr_sens-15, yarr_sens-15, xarr_sens+15, yarr_sens+15)
            txt = "AR"

        my_canvas.itemconfigure(txt_sens, text=txt)

    # cle
    if(cle != old_cle):
        old_cle = cle
        if(cle == RETIRE):
            my_canvas.itemconfigure(line_cmd_cle,state=HIDDEN)
        else:
            my_canvas.itemconfigure(line_cmd_cle,state=NORMAL)

        if(cle == CLE_OFF):
            my_canvas.coords(line_cmd_cle, xc_cle, yc_cle, x0_cle, y0_cle)
            my_canvas.itemconfigure(line_volt_bat72,state=HIDDEN)
        if(cle == CLE_ON):
            my_canvas.coords(line_cmd_cle, xc_cle, yc_cle, x1_cle, y1_cle)
            my_canvas.itemconfigure(line_volt_bat72,state=NORMAL)

    # manette frein
    if(manette_frein != old_manette_frein):
        old_manette_frein = manette_frein
        if(manette_frein==DESS):
            my_canvas.coords(line_cmd_fr, xc_boule_fr, yc_boule_fr, xdess_boule_fr, ydess_boule_fr)
            my_canvas.coords(oval_cmd_fr, xdess_boule_fr-b_fr, ydess_boule_fr-b_fr, xdess_boule_fr+b_fr, ydess_boule_fr+b_fr)
        if(manette_frein==RIEN):
            my_canvas.coords(line_cmd_fr, xc_boule_fr, yc_boule_fr, x0_boule_fr, y0_boule_fr)
            my_canvas.coords(oval_cmd_fr, x0_boule_fr-b_fr, y0_boule_fr-b_fr, x0_boule_fr+b_fr, y0_boule_fr+b_fr)
        if(manette_frein==SERR):
            my_canvas.coords(line_cmd_fr,  xc_boule_fr, yc_boule_fr, xserr_boule_fr, yserr_boule_fr)
            my_canvas.coords(oval_cmd_fr, xserr_boule_fr-b_fr, yserr_boule_fr-b_fr, xserr_boule_fr+b_fr, yserr_boule_fr+b_fr)

    # manette frein direct
    if(manette_freind != old_manette_freind):
        old_manette_freind = manette_freind
        if(manette_freind==DESS):
            x = xdess_boule_frd
            y = ydess_boule_frd
        elif(manette_freind==SERR):
            x = xserr_boule_frd
            y = yserr_boule_frd
        else:
            x = x0_boule_frd
            y = y0_boule_frd
        my_canvas.coords(line_cmd_frd, xc_boule_frd, yc_boule_frd, x, y)
        my_canvas.coords(oval_cmd_frd, x-20, y-20, x+20, y+20)

    # cerclo
    if(old_a_cerclo != a_cerclo):
        old_a_cerclo = a_cerclo

        x0 = xc_cerclo; y0 = yc_cerclo
        x1 = xc_cerclo + int(float( d_cerclo-15) * cos(radians(a_cerclo)))
        y1 = yc_cerclo - int(float(dy_cerclo-15) * sin(radians(a_cerclo)))
        x2 = xc_cerclo + int(float( d_cerclo+10) * cos(radians(a_cerclo)))
        y2 = yc_cerclo - int(float(dy_cerclo+10) * sin(radians(a_cerclo)))
        my_canvas.coords(line_cmd_cerclo, x1, y1, x2, y2)

        x1 = xc_cerclo + int(float(0.45* d_cerclo) * cos(radians(a_cerclo)))
        y1 = yc_cerclo - int(float(0.45*dy_cerclo) * sin(radians(a_cerclo)))
        x2 = xc_cerclo + int(float(0.55* d_cerclo) * cos(radians(a_cerclo)))
        y2 = yc_cerclo - int(float(0.55*dy_cerclo) * sin(radians(a_cerclo)))
        my_canvas.coords(line_aff_cerclo, x1, y1, x2, y2)

    # manette shuntage
    if(old_a_shunt != a_shunt):
        old_a_shunt = a_shunt

        x1 = xc_shunt + int(float(0.25*d_shunt) * cos(radians(a_shunt)))
        y1 = yc_shunt - int(float(0.25*d_shunt) * sin(radians(a_shunt)))
        x2 = xc_shunt + int(float(0.60*d_shunt) * cos(radians(a_shunt)))
        y2 = yc_shunt - int(float(0.60*d_shunt) * sin(radians(a_shunt)))
        my_canvas.coords(line_shunt, x1, y1, x2, y2)

        x1 = xc_shunt + int(float(0.80*d_shunt) * cos(radians(a_shunt)))
        y1 = yc_shunt - int(float(0.80*d_shunt) * sin(radians(a_shunt)))
        x2 = xc_shunt + int(float(     d_shunt) * cos(radians(a_shunt)))
        y2 = yc_shunt - int(float(     d_shunt) * sin(radians(a_shunt)))
        my_canvas.coords(line2_shunt, x1, y1, x2, y2)

        my_canvas.coords(oval_shunt, x2-15, y2-15, x2+15, y2+15)
        x2_shunt = x2
        y2_shunt = y2

        my_canvas.itemconfigure(txt_shunt, text=str(shuntage))

    # manette panto
    if(old_panto!=panto):
        old_panto = panto

        txt = " "; a=0.0
        if(panto==PANTO_RETIRE):
            my_canvas.itemconfigure(line_panto,state=HIDDEN)
            my_canvas.itemconfigure(oval_panto,state=HIDDEN)
        else:
            my_canvas.itemconfigure(line_panto,state=NORMAL)
            my_canvas.itemconfigure(oval_panto,state=NORMAL)

            if(panto==PANTO_0):
                a = -15.0; txt = "0"
            if(panto==PANTO_AR):
                a = -45.0; txt = "AR"
            if(panto==PANTO_AVAR):
                a = -75.0;  txt = "AV+AR"
            if(panto==PANTO_AV):
                a = -105.0; txt="AV"

            x = xc_panto + int(float(d_panto) * cos(radians(a)))
            y = yc_panto - int(float(d_panto) * sin(radians(a)))
            x2 = xc_panto - int(0.3 * float(d_panto) * cos(radians(a)))
            y2 = yc_panto + int(0.3 * float(d_panto) * sin(radians(a)))

            my_canvas.coords(line_panto, x2, y2, x, y)
            my_canvas.coords(oval_panto, x-15, y-15, x+15, y+15)

        a_panto = a
        my_canvas.itemconfigure(txt_panto, text=txt)

    # avertisseur
    if(manette_klaxon != old_manette_klaxon):
        old_manette_klaxon = manette_klaxon
        if(manette_klaxon==KL_AV):
            x = xav_klaxon;
            y = yav_klaxon
        elif(manette_klaxon==KL_AR):
            x = xarr_klaxon
            y = yarr_klaxon
        else:
            x = x0_klaxon
            y = y0_klaxon
        my_canvas.coords(line_cmd_klaxon, xc_klaxon, yc_klaxon, x, y)
        my_canvas.coords(oval_cmd_klaxon, x-20, y-20, x+20, y+20)

    # lssf
    if(old_lssf!=lssf or lssf==LSSF_CLI):
        old_lssf=lssf
        aff = 0
        if(lssf==LSSF_1):
            aff = 1
        if(lssf==LSSF_CLI and draw_update_cpt&4):
            aff = 1
        if(aff == 0):
            my_canvas.itemconfigure(oval_lssf,state=HIDDEN)
        else:
            my_canvas.itemconfigure(oval_lssf,state=NORMAL)

    # boutons
    if(old_dij_on != dij_on):
        old_dij_on = dij_on
        if(dij_on):
            y=y_haut_on
        else:
            y=y_haut_off
        my_canvas.coords(rect_dij_on, x_dij_on-5, y-5, x_dij_on+5, y+5)
    if(old_dij_arm != dij_arm):
        old_dij_arm = dij_arm
        if(dij_arm):
            y=y_haut_on
        else:
            y=y_haut_off
        my_canvas.coords(rect_dij_arm, x_dij_arm-5, y-5, x_dij_arm+5, y+5)
    if(old_comp_auto != comp_auto):
        old_comp_auto = comp_auto
        if(comp_auto):
            y=y_haut_on
        else:
            y=y_haut_off
        my_canvas.coords(rect_comp_auto, x_comp_auto-5, y-5, x_comp_auto+5, y+5)
    if(old_comp_direct != comp_direct):
        old_comp_direct = comp_direct
        if(comp_direct):
            my_canvas.itemconfigure(rect_comp_direct,state=HIDDEN)
        else:
            my_canvas.itemconfigure(rect_comp_direct,state=NORMAL)
        y=y_haut_off
        my_canvas.coords(rect_comp_direct, x_comp_direct-5, y-5, x_comp_direct+5, y+5)
    if(old_ligne_train != ligne_train):
        old_ligne_train = ligne_train
        if(ligne_train):
            my_canvas.itemconfigure(rect_ligne_train,state=HIDDEN)
        else:
            my_canvas.itemconfigure(rect_ligne_train,state=NORMAL)
        y=y_haut_off
        my_canvas.coords(rect_ligne_train, x_ligne_train-5, y-5, x_ligne_train+5, y+5)
    if(old_serie != serie):
        old_serie = serie
        if(serie):
            my_canvas.itemconfigure(rect_serie,state=HIDDEN)
        else:
            my_canvas.itemconfigure(rect_serie,state=NORMAL)
        y=y_haut_off
        my_canvas.coords(rect_serie, x_serie-5, y-5, x_serie+5, y+5)
    if(old_fep != fep):
        old_fep = fep
        if(fep):
            my_canvas.itemconfigure(rect_fep,state=HIDDEN)
        else:
            my_canvas.itemconfigure(rect_fep,state=NORMAL)
        y=y_haut_off
        my_canvas.coords(rect_fep, x_fep-5, y-5, x_fep+5, y+5)

    if(old_cvs != cvs):
        old_cvs = cvs
        if(cvs):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_cvs, x_cvs-5, y-5, x_cvs+5, y+5)
    if(old_cabine != cabine):
        old_cabine = cabine
        if(cabine):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_cabine, x_cabine-5, y-5, x_cabine+5, y+5)
    if(old_pupitre != pupitre):
        old_pupitre = pupitre
        if(pupitre):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_pupitre, x_pupitre-5, y-5, x_pupitre+5, y+5)
    if(old_fanal_g != fanal_g):
        old_fanal_g = fanal_g
        if(fanal_g):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_fanal_g, x_fanal_g-5, y-5, x_fanal_g+5, y+5)
    if(old_fanal_d != fanal_d):
        old_fanal_d = fanal_d
        if(fanal_d):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_fanal_d, x_fanal_d-5, y-5, x_fanal_d+5, y+5)
    if(old_projo_g != projo_g):
        old_projo_g = projo_g
        if(projo_g):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_projo_g, x_projo_g-5, y-5, x_projo_g+15, y+5)
    if(old_projo_d != projo_d):
        old_projo_d = projo_d
        if(projo_d):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_projo_d, x_projo_d-5, y-5, x_projo_d+5, y+5)
    if(old_arm_vacma != arm_vacma):
        old_arm_vacma = arm_vacma
        if(arm_vacma):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_arm_vacma, x_arm_vacma-5, y-5, x_arm_vacma+5, y+5)
    if(old_ess_vacma != ess_vacma):
        old_ess_vacma = ess_vacma
        if(ess_vacma):
            y=y_bas_on
        else:
            y=y_bas_off
        my_canvas.coords(rect_ess_vacma, x_ess_vacma-5, y-5, x_ess_vacma+5, y+5)

    if(old_ind_dij != ind_dij):
        old_ind_dij = ind_dij
        if(ind_dij):
            txt = "/"
        else:
            txt = ""
        my_canvas.itemconfigure(txt_picto_dij, text=txt)

    if(old_ind_zero != ind_zero):
        old_ind_zero = ind_zero
        if(ind_zero):
            txt = "0"
        else:
            txt = ""
        my_canvas.itemconfigure(txt_picto_zero, text=txt)


def set_txt_cran():
    global txt_cran

    if(cran_fr>0 or cran==0 and (cerclo==CERCLO_P or cerclo==CERCLO_FRMOINS or cerclo==CERCLO_FRSTOP or cerclo==CERCLO_FRPLUS or cerclo==CERCLO_FR)):
        txt = str(cran_fr) + " fr"
    else:
        txt = str(cran)
        if(couplage == SERIE):
            txt += " --"
        if(couplage == SERIE_PARA):
            txt += " -/"
        if(couplage == PARA):
            txt += " //"
    my_canvas.itemconfigure(txt_cran, text=txt)



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# SIMU FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

# les parametres de simulations sont maintenant au debut du programme
vit_sens = 0.0    #vit mais avec un signe +=AV, -=AR
simu_tic = 0


def simu():
    global vit; global vit_sens; global mem_sens
    global aig_val_vit_0_210
    global pression_cg_0_5; global pression_cf_0_5; global pression_cfd_0_5
    global aig_val_rp_0_10; global aig_val_re_0_10; global aig_val_cg_0_10; global aig_val_cf_0_10
    global dbg_txt
    global lssf_dcpt
    global robinet_au
    global manette_acc_0_100
    global aig_volt_ligne_0_1500; global aig_volt_bat_0_100; global aig_amp_m1_0_1000; global aig_amp_m2_0_1000; global aig_amp_fr_0_1000
    global cran; global couplage; global shuntage; global old_cerclo; global cran_fr
    global simu_tic
    global dj_on; global ind_dij; global ind_zero

    simu_tic+=1

    mode = ""

    #panto / dij / zero
    if(dij_on and dij_arm and robinet_au==0 and cle==CLE_ON):
        dj_on = 1
    if((dij_on==0 and cle==CLE_ON) or robinet_au):
        dj_on = 0

    if(dj_on==0 and cle==CLE_ON):
        ind_dij = 1
    else:
        ind_dij = 0

    if(panto==PANTO_AR or panto==PANTO_AVAR or panto==PANTO_AV):
        aig_volt_ligne_0_1500 = 1500
    else:
        aig_volt_ligne_0_1500 = 0

    if(cle==CLE_ON and (cran==0 or palette_sens==ARRET or palette_sens==RETIRE)):
        ind_zero = 1
    else:
        ind_zero = 0

    if(aig_volt_ligne_0_1500 and dj_on and (palette_sens==AV or palette_sens==AR)):
        power = 1
    else:
        power = 0

    #entrees   cerclo --> crans
    if(cle != CLE_ON):
        cran = 0
        cran_f = 0

    if(cran==0 and couplage==SERIE_PARA and serie==1):
        couplage=SERIE
    if(cran==0 and couplage==SERIE and serie==0):
        couplage=SERIE_PARA

    if(cle == CLE_ON):
        if(cerclo==CERCLO_0 and simu_tic&1):
            if(couplage==PARA and cran==0):
                couplage=SERIE_PARA; cran=28
            elif(cran>0):
                cran -= 1
            if(cran_fr>0):
                cran_fr -= 1
    if(cle == CLE_ON and cran_fr==0):
        if(cerclo==CERCLO_MOINS and old_cerclo==CERCLO_STOP):
            if(cran>0):
                cran -= 1
            elif(cran==0 and couplage==PARA):
                couplage=SERIE_PARA; cran=28
        if(cerclo==CERCLO_PLUS and old_cerclo==CERCLO_STOP):
            if(couplage==SERIE or couplage==SERIE_PARA):
                if(cran<28):
                    cran += 1
                elif(cran==28 and couplage==SERIE_PARA):
                    couplage=PARA; cran=0
            elif(couplage==PARA):
                if(cran<20):
                    cran += 1
        if(cerclo==CERCLO_PR and simu_tic&1):
            if(couplage==SERIE or couplage==SERIE_PARA):
                if(cran<28):
                    cran += 1
            if(couplage==PARA):
                if(cran<20):
                    cran += 1
    if(cle == CLE_ON and cran==0 and couplage!=PARA):
        if(cerclo==CERCLO_FRMOINS and old_cerclo==CERCLO_FRSTOP):
            if(cran_fr>0):
                cran_fr -= 1
        if(cerclo==CERCLO_FRPLUS and old_cerclo==CERCLO_FRSTOP):
            if(cran_fr<25):
                    cran_fr += 1
        if(cerclo==CERCLO_FR and simu_tic&1):
            if(cran_fr<25):
                cran_fr += 1

    old_cerclo = cerclo

    set_txt_cran()

    # calcul traction
    t = 0.0; amp = 0.0
    if(couplage==SERIE):
        t = 0.25 * float(cran + shuntage) / float(28 + 8)
    if(couplage==SERIE_PARA):
        t = 0.5 * float(cran + shuntage) / float(28 + 8)
    if(couplage==PARA):
        #t = 1.0 * float(8 + cran + shuntage) / float(28 + 8)
        tmin = 0.5 * (28.0 + 0.0) / (28.0 + 8.0)   #cran0 // env cran28 --//
        tmax = 1.0
        t = tmin + (tmax - tmin) * float(cran + shuntage) / (20.0 + 8.0)
    traction_0_100 = 100.0 * t
    amp = 100 * t

    v_cible = vmax * traction_0_100 / 100.0
    t_cible=0

    #arret
    if(traction_0_100==0 and vit==0.0):
        mode = "ARRET "

    #marche sur l'erre
    elif(traction_0_100==0 or v_cible<vit or robinet_au==1 or power==0):
        mode = "ERRE "
        dv = (100.0/t_100_0_erre)/10
        v = vit - dv
        if(v<0.0):
            v=0.0
        vit = v
        t_cible = vit / (10*dv)

    #acceleration
    elif(v_cible>vit and palette_sens!=ARRET and power):
        dv = (100.0/t_0_100_mot)/10.0     * traction_0_100 / 100.0
        v=vit+dv
        if(v>v_cible):
            vit=v_cible
        else:
            vit=v
        mode = "ACC "
        t_cible = (v_cible-vit) / (10*dv)

    #frein rheostatique
    if(cran_fr>0 and vit>20.0):    #vit pour simuler que le frein rheostatique ralenti mais n'arrete pas
        mode += "FR-RHEO "
        dv = (100.0/t_100_0_frrh)/10.0    *   float(cran_fr)/25.0
        v = vit - dv
        if(v<0.0): #ne peut pas arriver avec le frein rheostatique
            v=0.0
        vit = v
        t_cible = (vit-20.0) / (10*dv)
        v_cible = 20.0

    #precalcul des pressions
    #manette frein -> cg
    if(manette_frein == SERR):
        if(palette_service == SERVICE or palette_service == NEUTRE):
            dp = (1.5 / t_press_3b5_5b) / 10.0
            p = pression_cg_0_5 - dp
            if(p < 0.0):
                p = 0.0
            pression_cg_0_5 = p
    if(manette_frein == DESS):
        if(palette_service == SERVICE):
            dp = (1.5 / t_press_3b5_5b) / 10.0
            p = pression_cg_0_5 + dp
            if(p > 5.0):
                p = 5.0
            pression_cg_0_5 = p
    if(btn_grand_debit):
        if(palette_service == SERVICE):
            dp = (1.5 / t_press_3b5_5b) / 10.0
            p = pression_cg_0_5 + 2*dp
            if(p > 5.0):
                p = 5.0
            pression_cg_0_5 = p

    #manette frein direct -> cfd
    if(manette_freind == SERR):
        if(palette_service == SERVICE or palette_service == NEUTRE):
            dp = (5.0 / t_press_0b_5b_fd) / 10.0
            p = pression_cfd_0_5 + dp
            if(p > 5.0):
                p = 5.0
            pression_cfd_0_5 = p
    if(manette_freind == DESS):
        if(palette_service == SERVICE):
            dp = (5.0 / t_press_0b_5b_fd) / 10.0
            p = pression_cfd_0_5 - dp
            if(p < 0.0):
                p = 0.0
            pression_cfd_0_5 = p

    #robinet au -> cg
    if(robinet_au):
        dp = (1.5 / t_press_au_5b_3b5) / 10.0
        p = pression_cg_0_5 - dp
        if(p < 0.0):
            p = 0.0
        pression_cg_0_5 = p

    #cg=5 -> cf=0, cg=3.5 -> cf=5
    p =  (5.0 / 1.5) * (5.0 - pression_cg_0_5)
    if(p > 5.0):
        p = 5.0
    if(p < 0.0):
        p = 0.0
    pression_cf_0_5 = p

    fr_0_100 = 100.0 * (pression_cf_0_5 / 5.0)
    aig_val_rp_0_10 = pression_rp_0_10
    aig_val_cg_0_10 = pression_cg_0_5
    aig_val_re_0_10 = pression_cg_0_5
    aig_val_cf_0_10 = pression_cf_0_5

    #freinage pneumatique (sabots + disques)
    if(fr_0_100>0.0):
        mode += "FR-AUTO "
        dv = (100.0/t_100_0_fr)/10.0    *   fr_0_100 / 100.0
        v = vit - dv
        if(v<0.0):
            v=0.0
        vit = v
        t_cible = vit / (10*dv)
        v_cible = 0

    #frein_direct
    if(pression_cfd_0_5 > pression_cf_0_5):
        mode += "FR-DIR "
        dv = (100.0/t_100_0_frd)/10.0    *   (pression_cfd_0_5 - pression_cf_0_5) / 5.0
        v = vit - dv
        if(v<0.0):
            v=0.0
        vit = v
        t_cible = vit / (10*dv)
        v_cible = 0
        aig_val_cf_0_10 = pression_cfd_0_5

    #vitesse combinee avec sens
    if(palette_sens==AV):
        vit_sens = vit
        mem_sens = AV
    if(palette_sens==AR):
        vit_sens = -vit
        mem_sens = AR
    if(palette_sens==ARRET):
        vit_sens = 0

    #sorties
    aig_val_vit_0_210 = vit

    if(mode==""):
        mode = "STABLE"

    if(cle == CLE_ON):
        aig_volt_bat_0_100 = 72.0
    else:
        aig_volt_bat_0_100 = 0.0

    if(power):
        aig_amp_m1_0_1000 = 1000.0 * amp / 100.0
        aig_amp_m2_0_1000 = aig_amp_m1_0_1000
    else:
        aig_amp_m1_0_1000 = 0.0
        aig_amp_m2_0_1000 = 0.0

    #lssf
    if(lssf == LSSF_CLI):
        if(lssf_dcpt==0):
            robinet_au = 1
        else:
            lssf_dcpt -= 1

    zetxt = "VIT="
    if(palette_sens==AV):
        zetxt += "+"
    if(palette_sens==AR):
        zetxt += "-"
    zetxt += str(round(vit,0)) + "kmph"
    zetxt += " VCIBLE=" + str(round(v_cible,0)) + "kmph"
    zetxt += " TCIBLE=" + str(round(t_cible,0)) + "s"
    zetxt += " COUPLAGE="
    if(couplage==SERIE):
         zetxt += "SERIE"
    if(couplage==SERIE_PARA):
         zetxt += "SERIE_PARA"
    if(couplage==PARA):
         zetxt += "PARA"
    zetxt += " CRAN=" + str(cran)
    zetxt += " CRANFR=" + str(cran_fr)
    zetxt += " ACC=" + str(round(traction_0_100,0)) + "%"
    zetxt += " MODE=" + mode

    ##print(zetxt)
    my_canvas.itemconfigure(dbg_txt,text=zetxt)

    return



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# SERIAL FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

#mise a jour de l'arduino avec les nouvelles valeurs
#
# protocol:
# s s s s s s s s p <0..sens> <vit0-255> k <0..KL_AV.KL_AR> 0     1     e
#                                                           |<a0> |<a1> |<e0> <e1>
#
#  e0:   0 AU FRD-DESS FRD-SERR FRA-DESS FRA-SERR SENS_AV SENS-AR
MSK_AU       = 64
MSK_FRD_DESS = 32
MSK_FRD_SERR = 16
MSK_FRA_DESS = 8
MSK_FRA_SERR = 4
MSK_SENS_AV  = 2
MSK_SENS_AR  = 1
#  e1:   0  0        0        0        0        0  KL_AV    KL_AR
MSK_KL_AV = 2
MSK_KL_AR = 1
#  a0: 0-255 -> cerclo
#  e1: 0-255 -> shuntage

first = 1; old_e1 = 0; old_e0 = 0; old_a0 = 0; old_a1 = 0

def serial_update():
    global ser; global serial_ok
    global manette_acc_0_100; global palette_sens; global manette_klaxon
    global robinet_au; global manette_freind; global manette_frein;
    global first; global old_e1; global old_e0; global old_a0; global old_a1;
    global a_cerclo; global cerclo
    global a_shunt;  global shuntage

    if(serial_ok==0):
        return

    try:
        nb_rx=0
        while(ser.inWaiting()):
            nb_rx+=1
            rb = ser.read(1)
            if(nb_rx==1): a0 = rb[0]
            if(nb_rx==2): a1 = rb[0]
            if(nb_rx==3): e0 = rb[0]
            if(nb_rx==4): e1 = rb[0]
            print("RX:" + str(rb[0]))

        if(nb_rx==4 and first==0):

            if(abs(old_a0 - a0)>5):
                #a0 = 255 - a0    #pour inverser le potentiometre
                # 255--218 "PR" 198 "+" 178 "STOP" 158 "-" 138 "0" 118 "P" 98 "-" 78 "STOP" 58 "+" 38 "FR" 18--0
                if(a0>18  and a0<=38 ):
                    a_cerclo =  -29.0; cerclo = CERCLO_FR
                if(a0>38  and a0<=58 ):
                    a_cerclo =  -42.0; cerclo = CERCLO_FRPLUS
                if(a0>58  and a0<=78 ):
                    a_cerclo = -56.0; cerclo = CERCLO_FRSTOP
                if(a0>78  and a0<=98 ):
                    a_cerclo = -67.0; cerclo = CERCLO_FRMOINS
                if(a0>98  and a0<=118):
                    a_cerclo =  -79.0; cerclo = CERCLO_P
                if(a0>118 and a0<=138):
                    a_cerclo =  -92.0; cerclo = CERCLO_0
                if(a0>138 and a0<=158):
                    a_cerclo = -105.0; cerclo = CERCLO_MOINS
                if(a0>158 and a0<=178):
                    a_cerclo = -118.0; cerclo = CERCLO_STOP
                if(a0>178 and a0<=198):
                    a_cerclo = -131.0; cerclo = CERCLO_PLUS
                if(a0>198 and a0<=218):
                    a_cerclo = -144.0; cerclo = CERCLO_PR
                old_a0 = a0

            if(abs(old_a1 - a1)>5):
                # a1 = 255 - a1    #pour inverser le potentiometre
                # 255 "8" "7" "6" "5" "4" "3" "2" "1" "0" 128
                a0 = 15.0
                a8 = a0 - 60.0
                if(a1<128):
                    shuntage = 0
                    a_shunt = a0
                elif(a1>= 128+10*9):
                    shuntage = 8
                    a_shunt = a8
                else:
                    for i in range(0, 9):
                        a = 128 + 10 * i
                        if(a1>=a and a1<(a+10)):
                            shuntage = i
                            a_shunt = a0 + float(shuntage)/8.0 * (a8 - a0)
                            break
                old_a0 = a1

            e0 ^= 255; e1 ^= 255;

            if((old_e0 & MSK_AU)==0 and (e0 & MSK_AU)):
                robinet_au ^= 1

            if(e0 & MSK_SENS_AV):
                palette_sens = AV
            elif(e0 & MSK_SENS_AR):
                palette_sens = AR
            elif(old_e0 & MSK_SENS_AV):
                palette_sens = ARRET
            elif(old_e0 & MSK_SENS_AR):
                palette_sens = ARRET

            if(e0 & MSK_FRA_DESS):
                manette_frein = DESS
            elif(e0 & MSK_FRA_SERR):
                manette_frein = SERR
            elif(old_e0 & MSK_FRA_DESS):
                manette_frein = RIEN
            elif(old_e0 & MSK_FRA_SERR):
                manette_frein = RIEN

            if(e0 & MSK_FRD_DESS):
                manette_freind = DESS
            elif(e0 & MSK_FRD_SERR):
                manette_freind = SERR
            elif(old_e0 & MSK_FRD_DESS):
                manette_freind = RIEN
            elif(old_e0 & MSK_FRD_SERR):
                manette_freind = RIEN

            if(e1 & MSK_KL_AV):
                manette_klaxon = KL_AV
            elif(e1 & MSK_KL_AR):
                manette_klaxon = KL_AR
            elif(old_e1 & MSK_KL_AV):
                manette_klaxon = KL_0
            elif(old_e1 & MSK_KL_AR):
                manette_klaxon = KL_0

            old_e1 = e1
            old_e0 = e0

        first = 0

        # 1) synchros
        data = ord('s')
        for i in range(0,8):
            ser.write(bytes([data]))

        # 2) pwm command (sens + vit)
        ser.write(bytes([ord('p')]))
        #sens
        if(mem_sens == AV):
            sens = 1      #sens +
        else:
            sens = 0      #sens -
        sens ^= pwm_inv_sens
        ser.write(bytes([sens]))
        #print("TX:"+str(sens))
        #vit
        if(vit==0.0):
            v = 0
        else:
            v = pwm_min + int(float(pwm_max - pwm_min) * (vit / pwm_vit_max))
            if(v > pwm_max):
                v = pwm_max
        ser.write(bytes([v]))
        #print("TX:"+str(v))

        # 3) dcc command (adr + sens + vit + fct)
        ser.write(bytes([ord('d')]))
        #adresse
        ser.write(bytes([dcc_adr]))
        #sens
        if(mem_sens == AV):
            sens = 1      #sens +
        else:
            sens = 0      #sens -
        sens ^= dcc_inv_sens
        ser.write(bytes([sens]))
        #vit
        if(vit==0.0):
            v = 0
        else:
            v = dcc_min + int(float(dcc_max - dcc_min) * (vit / dcc_vit_max))
            if(v > dcc_max):
                v = dcc_max
        ser.write(bytes([v]))
        # fct (F0 si au moins un des boutons des phares est actif)
        fct = 0
        if(fanal_g):
            fct = 1
        if(fanal_d):
            fct = 1
        if(projo_g):
            fct = 1
        if(projo_d):
            fct = 1
        ser.write(bytes([fct]))

        # 3) cmd klaxon (plus utilise car le timer 2 est utilise par le DCC)
        #ser.write(bytes([ord('k')]))
        #data = 0
        #if(manette_klaxon == KL_AV):  # 0.0.0.0.0.0.KLAV.KLAR
        #    data |= 2
        #if(manette_klaxon == KL_AR):  # 0.0.0.0.0.0.KLAV.KLAR
        #    data |= 1
        #ser.write(bytes([data]))
        #print("TX:"+str(data))

        # 4) read analog 0 and 1
        ser.write(bytes([ord('0')]))
        ser.write(bytes([ord('1')]))

        # 5) read boutons
        ser.write(bytes([ord('e')]))

    except:
        serial_ok=0
        print("ERROR: Perte de la liaison serie")

    return



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# NETWORK FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

def net_connect():
    if(use_network==0):
        return

    if(use_local):
        adr = socket.gethostbyname(socket.gethostname())
    else:
        adr = server_ip_adr

    s.connect((adr, server_port))           #uu: mettre une touche d'inversion ex: I
    print("NETWORK: connected")
    welcome = s.recv(1024).decode()
    print("NETWORK: server string: \"" + welcome + "\"")
    s.send("cabine netv1 cc6500".encode())
    return

net_connect()

def net_disconnect():
    if(use_network==0):
        return
    s.close()
    return

old_msg = ""

def net_update():
    global old_msg

    if(use_network==0):
        return

    # adr
    msg = "a" + str(dcc_adr)

    # sens
    if(mem_sens == AV):
        sens = 1      #sens +
    else:
        sens = 0      #sens -
    sens ^= dcc_inv_sens
    if(sens):
        msg += " s+"
    else:
        msg += " s-"

    # vit
    if(vit==0.0):
        v = 0
    else:
        v = net_min + int(float(net_max - net_min) * (vit / dcc_vit_max))
        if(v > net_max):
            v = net_max
    msg += " v" + str(v)

    # fct (F0 si au moins un des boutons des phares est actif)
    fct = 0
    if(fanal_g):
        fct = 1
    if(fanal_d):
        fct = 1
    if(projo_g):
        fct = 1
    if(projo_d):
        fct = 1
    if(fct):
        msg += " f0+"
    else:
        msg += " f0-"

    msg += "\n"

    # send msg
    if(msg != old_msg):
        print("NETWORK: send: " + msg)
        s.send(msg.encode())
        old_msg = msg

    return



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# CALLBACKS
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

cpt_avr = 0
cpt_err = 0

def timer_1s_cb():
    global cpt_avr
    #global aig_val_vit_0_210; global aig_val_trm_0_2500
    #global aig_val_rp_0_10; global aig_val_cg_0_10; global aig_val_cf_0_10
    cpt_avr += 1
    ##print("----------------------------------")
    ##print("cpt_avr = " + str(cpt_avr));
    #aig_val_vit_0_210 = float(s_pot.get())
    #aig_val_trm_0_2500 = float(s_pot.get())
    #aig_val_rp_0_10 = float(s_pot.get())
    #aig_val_cg_0_10 = float(s_pot.get())
    #aig_val_cf_0_10 = float(s_pot.get())

    simu()

    serial_update()
    net_update()

    draw_update()


mouse_owner = ""
x_press = 0
y_press = 0
a_mem = 0

def callback_my_canvas_mouse_press(event):
    global mouse_owner; global x_press; global y_press
    global a_mem;
    global lssf
    global btn_grand_debit
    global dij_on; global dij_arm; global comp_auto; global comp_direct; global ligne_train; global serie; global fep
    global cvs; global cabine; global pupitre; global fanal_g; global fanal_d; global projo_g; global projo_d; global arm_vacma; global ess_vacma
    global panto
    global alerte

    m_x = int(event.x); x_press = m_x
    m_y = int(event.y); y_press = m_y
    #print("mouse press at " + str(m_x) + " " + str(m_y))

    if(m_x>xc_au and m_x<x_au and m_y>yc_au and m_y<y_au):
        mouse_owner = "robinet_au"

    if(m_x>xc_cmd_alerte-10 and m_x<xc_cmd_alerte+10 and m_y>yc_cmd_alerte-10 and m_y<yc_cmd_alerte+10):
        alerte ^= 1

    if(m_x>xc_srv-d_srv-10 and m_x<xc_srv+d_srv+10 and m_y>yc_srv-d_srv-10 and m_y<yc_srv+d_srv+10):
        mouse_owner = "service"

    if(m_x>xc_cle-10 and m_x<x0_cle+10 and m_y>yc_cle-10 and m_y<x1_cle+10):
        mouse_owner = "cle"

    if(m_x>xav_sens-15 and m_x<xarr_sens+15 and m_y>yav_sens-15 and m_y<yarr_sens+15):
        mouse_owner = "sens"

    elif(m_x>x2_shunt-15 and m_x<x2_shunt+15 and m_y>y2_shunt-15 and m_y<y2_shunt+15):
        a_mem = a_shunt
        mouse_owner = "shunt"

    #elif(m_x>xc_cerclo-d_cerclo-15 and m_x<xc_cerclo+d_cerclo+15 and m_y>yc_cerclo-dy_cerclo-15 and m_y<yc_cerclo+dy_cerclo+15):
    elif(m_x>xc_cerclo-d_cerclo-15 and m_x<xc_cerclo+d_cerclo+15 and m_y>yc_cerclo-dy_cerclo-15 and m_y<440):
        a_mem = a_cerclo
        mouse_owner = "cerclo"

    if(m_x>x0_boule_fr-20 and m_x<x0_boule_fr+20 and m_y>y0_boule_fr-20 and m_y<y0_boule_fr+20):
        mouse_owner = "frein"

    x = xc_grand_debit; y = yc_grand_debit
    if(m_x>x-15 and m_x<x+15 and m_y>y-15 and m_y<y+15):
        btn_grand_debit = 1
        mouse_owner = "frein_gdb"

    if(m_x>x0_boule_frd-20 and m_x<x0_boule_frd+20 and m_y>y0_boule_frd-20 and m_y<y0_boule_frd+20):
        mouse_owner = "freind"

    if(m_x>x0_klaxon-20 and m_x<x0_klaxon+20 and m_y>y0_klaxon-20 and m_y<y0_klaxon+20):
        mouse_owner = "klaxon"

    elif(m_x>xc_panto-d_panto-10 and m_x<xc_panto+d_panto+10 \
    and m_y>yc_panto-10 and m_y<yc_panto+d_panto+10):
        if(panto==PANTO_RETIRE):
            panto=PANTO_0
        else:
            mouse_owner = "panto"
            a_mem = a_panto

    if(lssf == LSSF_CLI):
        if(m_x>xc_ack_lssf-20 and m_x<xc_ack_lssf+20 and m_y>yc_ack_lssf-20 and m_y<yc_ack_lssf+20):
            lssf = LSSF_1

    #if(m_y>y_haut_on-10 and m_y<y_haut_off+10 and cle==CLE_ON):
    if(m_y>440 and m_y<y_haut_off+10 and cle==CLE_ON):
        if(m_x>x_dij_on-10 and m_x<x_dij_on+10):
            dij_on ^= 1
        if(m_x>x_dij_arm-10 and m_x<x_dij_arm+10):
            dij_arm = 1
            mouse_owner = "dij_arm"
        if(m_x>x_comp_auto-10 and m_x<x_comp_auto+10):
            comp_auto ^= 1
        if(m_x>x_comp_direct-10 and m_x<x_comp_direct+10):
            comp_direct ^= 1
        if(m_x>x_ligne_train-10 and m_x<x_ligne_train+10):
            ligne_train ^= 1
        if(m_x>x_serie-10 and m_x<x_serie+10):
            serie ^= 1
        if(m_x>x_fep-10 and m_x<x_fep+10):
            fep ^= 1

    if(m_y>y_bas_on-10 and m_y<y_bas_off+10 and cle==CLE_ON):
        if(m_x>x_cvs-10 and m_x<x_cvs+10):
            cvs ^= 1
        if(m_x>x_cabine-10 and m_x<x_cabine+10):
            cabine ^= 1
        if(m_x>x_pupitre-10 and m_x<x_pupitre+10):
            pupitre ^= 1
        if(m_x>x_fanal_g-10 and m_x<x_fanal_g+10):
            fanal_g ^= 1
        if(m_x>x_fanal_d-10 and m_x<x_fanal_d+10):
            fanal_d ^= 1
        if(m_x>x_projo_g-10 and m_x<x_projo_d+10):  #les projos sont lies
            projo_g ^= 1
            projo_d = projo_g
        if(m_x>x_arm_vacma-10 and m_x<x_arm_vacma+10):
            arm_vacma = 1
            mouse_owner = "arm_vacma"
        if(m_x>x_ess_vacma-10 and m_x<x_ess_vacma+10):
            ess_vacma ^= 1

    return


def callback_my_canvas_mouse_move(event):
    global manette_frein; global manette_freind
    global manette_klaxon
    global cerclo; global a_cerclo    # = 180*atan2(my_y-xc_cerclo,my_x-yc_cerclo)/PI
    global shuntage; global a_shunt
    global panto;
    m_x = int(event.x);
    m_y = int(event.y);

    #print("mouse move at " + str(m_x) + " " + str(m_y) + " owner=" + mouse_owner)

    if(mouse_owner=="panto"):
        if(panto==PANTO_0 and abs(m_y-y_press)>75):
            panto=PANTO_RETIRE
            mouse_owner==""
        else:
            a_press  = 180.0*atan2(float(x_press-xc_panto),float(0-(y_press-yc_panto)))/PI
            a_press2 = 180.0*atan2(float(m_x-xc_panto),float(0-(m_y-yc_panto)))/PI
            a = a_mem - (a_press2 - a_press)
            while(a>180.0):
                a -= 360.0
            while(a<=-180.0):
                a += 360.0
            if(a<0.0 and a>-30.0):
                panto = PANTO_0
            if(a<-30.0 and a>-60.0):
                panto = PANTO_AR
            if(a<-60.0 and a>-90.0):
                panto = PANTO_AVAR
            if(a<-90.0 and a>-120.0):
                panto = PANTO_AV

    if(mouse_owner=="shunt"):
        a_press  = 180.0*atan2(float(x_press-xc_shunt),float(0-(y_press-yc_shunt)))/PI
        a_press2 = 180.0*atan2(float(m_x-xc_shunt),float(0-(m_y-yc_shunt)))/PI
        a = a_mem - (a_press2 - a_press)
        while(a>180.0):
            a -= 360.0
        while(a<=-180.0):
            a += 360.0
        #a_shunt = a      # -180 --> +180
        a0 = 15.0
        a8 = a0 - 60.0
        v = 8.0 * (a - a0) / (a8 - a0)
        if(v<0.0):
            v=0.0
        v=int(v)
        if(v>8):
            v=8
        a= a0 + float(v)/8.0 * (a8 - a0)
        a_shunt = a
        shuntage = v

    if(mouse_owner=="cerclo"):
        a_press  = 180.0*atan2(float(x_press-xc_cerclo),float(0-(y_press-yc_cerclo)))/PI
        a_press2 = 180.0*atan2(float(m_x-xc_cerclo),float(0-(m_y-yc_cerclo)))/PI
        a = a_mem - (a_press2 - a_press)
        while(a>180.0):
            a -= 360.0
        while(a<=-180.0):
            a += 360.0
        a_cerclo = a      # -180 --> +180
        #PR   +     S    -   0   P   -   S   +   FR
        #-144 -131 -118 -105 -92 -79 -67 -56 -42 -29
        if(a<-138.0):
            a = -144.0
            cerclo = CERCLO_PR
        elif(a>=-138.0 and a<-125.0):
            a = -131.0
            cerclo = CERCLO_PLUS
        elif(a>=-125.0 and a<-111.0):
            a = -118.0
            cerclo = CERCLO_STOP
        elif(a>=-111.0 and a<-98.0):
            a = -105.0
            cerclo = CERCLO_MOINS
        elif(a>=-98.0 and a<-85.0):
            a = -92.0
            cerclo = CERCLO_0
        elif(a>=-85.0 and a<-74.0):
            a = -79.0
            cerclo = CERCLO_P
        elif(a>=-74.0 and a<-61.0):
            a = -67.0
            cerclo = CERCLO_FRMOINS
        elif(a>=-61.0 and a<-49.0):
            a = -56.0
            cerclo = CERCLO_FRSTOP
        elif(a>=-49.0 and a<-35.0):
            a = -42.0
            cerclo = CERCLO_FRPLUS
        elif(a>=-35.0 and a<-10.0):
            a = -29.0
            cerclo = CERCLO_FR
        a_cerclo = a

    elif(mouse_owner=="frein"):
        if(m_y < y_press-10):   #desserage
            manette_frein=DESS
        elif(m_y > y_press+10): #serrage
            manette_frein=SERR
        else:
            manette_frein=RIEN

    elif(mouse_owner=="freind"):
        if(m_y < y_press-10):   #desserage
            manette_freind=DESS
        elif(m_y > y_press+10): #serrage
            manette_freind=SERR
        else:
            manette_freind=RIEN

    elif(mouse_owner == "klaxon"):
        if(m_y < y_press-10):
            manette_klaxon = KL_AV
        elif(m_y > y_press+10):
            manette_klaxon = KL_AR
        else:
            manette_klaxon = KL_0

    return


def callback_my_canvas_mouse_release(event):
    global robinet_au
    global palette_service; global palette_sens; global cle
    global mouse_owner
    global manette_frein
    global manette_freind
    global manette_klaxon
    global btn_grand_debit
    global cerclo; global a_cerclo
    global manette_acc_0_100
    global dij_arm; global arm_vacma

    m_x = int(event.x);
    m_y = int(event.y);

    if(mouse_owner=="robinet_au"):
        robinet_au ^= 1
        manette_acc_0_100 = 0

    elif(mouse_owner == "cle"):
        v = cle
        if(v == RETIRE):
             v = CLE_OFF
        elif(v == CLE_OFF):
            if(m_x < x_press):
                v = CLE_ON
            if(m_x > x_press):
                v = RETIRE
        elif(v == CLE_ON):
            if(m_x > x_press):
                v = CLE_OFF
        cle = v

    elif(mouse_owner=="service"):
        v = palette_service
        print("service: v="+str(v))
        if(v==RETIRE):
            v=RETRAIT
        elif(v==RETRAIT):
            #if(abs(m_y-y_press)>abs(m_x-x_press)):
            if(abs(m_y-y_press)>75):
                v=RETIRE
            elif(m_x<x_press):
                v=NEUTRE
            elif(m_x>x_press):
                v=ISO
        elif(v==SERVICE):
            if(m_x<x_press):
                v=NEUTRE
            if(m_x>x_press):
                v=ISO
        elif(v==NEUTRE):
            if(m_y<y_press):
                v=SERVICE
            if(m_y>y_press):
                v=RETRAIT
        elif(v==ISO):
            if(m_y<y_press):
                v=SERVICE
            if(m_y>y_press):
                v=RETRAIT
        palette_service = v

    elif(mouse_owner=="sens"):
        #if(vit==0.0 and manette_acc_0_100==0):
        v=palette_sens
        if(v==RETIRE):
            v = ARRET
        elif(abs(m_x-x_press)>75):
            if(v == ARRET):
                v = RETIRE
        elif(m_y<(y_press-10)):
            if(v == AR):
                v = ARRET
            elif(v == ARRET):
                v = AV
        elif(m_y>(y_press+10)):
            if(v == AV):
                v = ARRET
            elif(v == ARRET):
                v = AR
        palette_sens=v

    elif(mouse_owner=="frein"):
        manette_frein=RIEN

    elif(mouse_owner=="freind"):
        manette_freind=RIEN

    elif(mouse_owner == "frein_gdb"):
        btn_grand_debit = 0

    elif(mouse_owner=="klaxon"):
        manette_klaxon=KL_0

    elif(mouse_owner=="cerclo"):
        if(cerclo==CERCLO_PR or cerclo==CERCLO_PLUS or cerclo==CERCLO_MOINS):   # PR or + or - -> S
            a_cerclo=-118.0
            cerclo = CERCLO_STOP
        if(cerclo==CERCLO_FR or cerclo==CERCLO_FRPLUS or cerclo==CERCLO_FRMOINS):   # FR- or FR+ or FR -> FRS
            a_cerclo=-56.0
            cerclo = CERCLO_FRSTOP
        if(cerclo==CERCLO_P):   # P -> 0
            a_cerclo=-92.0
            cerclo = CERCLO_0

    elif(mouse_owner == "dij_arm"):
        dij_arm = 0
    elif(mouse_owner == "arm_vacma"):
        arm_vacma = 0

    mouse_owner=""
    return


def callback_my_canvas_mouse_press_right(event):
    #global palette_service;

    m_x = int(event.x);
    m_y = int(event.y);

    #if(m_x>276 and m_x<306 and m_y>189 and m_y<252):
    #    if(palette_service==RETIRE):
    #        palette_service=ISO
    #    else:
    #        palette_service=RETIRE

    return


def callback_my_canvas_mouse_release_right(event):
    return


# mapping du pave numerique
#   / * -    -->    x       <--cerclo-->  -cerclo
# 7 8 9 +    -->    shunt-  DESS-D  DESS  +cerclo
# 4 5 6 +    -->    shunt+  SERR-D  SERR  +cerclo
# 1 2 3      -->    x       AU      AV    x
# 0 0 .      -->    0       0       AR    x
cerclo_in_freinage = 0
def cerclo_to_a(cerclo):
    if(cerclo == CERCLO_PR):
        return -144.0
    if(cerclo == CERCLO_PLUS):
        return -131.0
    if(cerclo == CERCLO_STOP):
        return -118.0
    if(cerclo == CERCLO_MOINS):
        return -105.0
    if(cerclo == CERCLO_0):
        return -92.0
    if(cerclo == CERCLO_P):
        return -79.0
    if(cerclo == CERCLO_FRMOINS):
        return -67.0
    if(cerclo == CERCLO_FRSTOP):
        return -56.0
    if(cerclo == CERCLO_FRPLUS):
        return -42.0
    if(cerclo == CERCLO_FR):
        return -29.0
    return -92.0

def cb_key(event):
    global manette_frein; global manette_freind;
    global palette_sens
    global robinet_au
    global lssf; global lssf_dcpt
    global cerclo; global a_cerclo
    global cerclo_in_freinage
    global vit
    global pwm_inv_sens
    global dcc_inv_sens

    k = repr(event.char)
    #print("pressed " + k)  #return 'a' with '

    if(k[1]=="/"):
        if(cerclo == CERCLO_FR):
            cerclo = CERCLO_FRSTOP
        elif(cerclo == CERCLO_FRSTOP):
            cerclo = CERCLO_P
        elif(cerclo == CERCLO_P):
            cerclo = CERCLO_0
        elif(cerclo == CERCLO_0):
            cerclo = CERCLO_STOP
            cerclo_in_freinage = 0
        elif(cerclo == CERCLO_STOP):
            cerclo = CERCLO_PR
    if(k[1]=="*"):
        if(cerclo == CERCLO_PR):
            cerclo = CERCLO_STOP
        elif(cerclo == CERCLO_STOP):
            cerclo = CERCLO_0
        elif(cerclo == CERCLO_0):
            cerclo = CERCLO_P
        elif(cerclo == CERCLO_P):
            cerclo = CERCLO_FRSTOP
            cerclo_in_freinage = 1
        elif(cerclo == CERCLO_FRSTOP):
            cerclo = CERCLO_FR
    if(k[1]=="+"):
        if(cerclo_in_freinage == 0):
            cerclo = CERCLO_PLUS
        if(cerclo_in_freinage == 1):
            cerclo = CERCLO_FRPLUS
    if(k[1]=="-"):
        if(cerclo_in_freinage == 0):
            cerclo = CERCLO_MOINS
        if(cerclo_in_freinage == 1):
            cerclo = CERCLO_FRMOINS
    if(k[1]=="/" or k[1]=="*" or k[1]=="+" or k[1]=="-"):
        a_cerclo = cerclo_to_a(cerclo)

    if(k[1]=="7"):
        if(shuntage>0):
            shuntage-=1
    if(k[1]=="4"):
        if(shuntage<8):
            shuntage+=1
    if(k[1]=="7" or k[1]=="4"):
        a0 = 15.0
        a8 = a0 - 60.0
        a_shunt = a0 + float(shuntage)/8.0 * (a8 - a0)

    if(k[1]=="2"):
        robinet_au ^= 1

    if(k[1]=="3"):
        #if(vit==0.0 and manette_acc_0_100==0):
        v = palette_sens
        if(v==AR):
            v=ARRET
        elif(v==ARRET):
            v=AV
        palette_sens = v

    if(k[1]=="."):
        #if(vit==0.0 and manette_acc_0_100==0):
        v = palette_sens
        if(v==AV):
            v=ARRET
        elif(v==ARRET):
            v=AR
        palette_sens = v

    if(k[1]=="9"):
        manette_frein=DESS
    if(k[1]=="6"):
        manette_frein=SERR

    if(k[1]=="8"):
        manette_freind=DESS
    if(k[1]=="5"):
        manette_freind=SERR

    if(k[1]=="l"):
        if(lssf == LSSF_0):
            lssf_dcpt = 50
            lssf = LSSF_CLI
        if(lssf == LSSF_1):
            lssf = LSSF_0

    if(k[1]==" "):    #arret immediat loco miniature avec la barre d'espace
        robinet_au = 1
        vit = 0

    elif(k[1]=="i"):
        pwm_inv_sens ^= 1
        dcc_inv_sens ^= 1

    return


def cb_key_release(event):
    global manette_frein; global manette_freind;
    global cerclo; global a_cerclo

    k = repr(event.char)    #print("released " + k)

    if(k[1]=="9" or k[1]=="6"):
        manette_frein = RIEN
    if(k[1]=="8" or k[1]=="5"):
        manette_freind = RIEN

    if(k[1]=="/" or k[1]=="*" or k[1]=="+" or k[1]=="-"):
        if(cerclo==CERCLO_PR or cerclo==CERCLO_PLUS or cerclo==CERCLO_MOINS):   # PR or + or - -> S
            cerclo = CERCLO_STOP
        if(cerclo==CERCLO_FR or cerclo==CERCLO_FRPLUS or cerclo==CERCLO_FRMOINS):   # FR- or FR+ or FR -> FRS
            cerclo = CERCLO_FRSTOP
        a_cerclo = cerclo_to_a(cerclo)

    return



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# GUI management
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

top = Tk()
top.title(TITLE)

row = 0

#e_v_div_mbps = Entry(top)
#b_reset      = Button(top, text = "reset", command = reset_cb)
#l_sec        = Label(top, text = "0 sec", font=("Helvetica", 16), fg = "#800000")
#l_v_div.grid(row = row, column = 0, sticky = W + E + N + S)
#e_v_div_mbps.grid(row = row, column = 1, sticky = W + E + N + S)
#b_reset.grid(row = row, column = 3, sticky = W + E + N + S)
#l_sec.grid(row = row, column = 1, sticky = W + E + N + S)
#e_v_div_mbps.delete(0, 1000); e_v_div_mbps.insert(0, "100")

img_pupitre = PhotoImage(file = fichier_pupitre)
img_dx = img_pupitre.width()
img_dy = img_pupitre.height()

my_canvas = Canvas(top, bg = "#cccccc", height = img_dy+20, width = img_dx)
my_canvas.grid(row = row, column = 0, columnspan = 4)
row=row+1

#---------------------------------------------------------------------------------------

#l_pot = Label(top, text ="Pot")
##s_pot = Scale(top, from_=0, to=210, orient=HORIZONTAL, tickinterval=10)
##s_pot = Scale(top, from_=0, to=2500, orient=HORIZONTAL, tickinterval=100)
#s_pot = Scale(top, from_=0, to=10, orient=HORIZONTAL, tickinterval=1)
#s_pot.grid(row=row,column=0,sticky=W+E+N+S)
#s_pot.grid(row=row,column=1,columnspan=4,sticky=W+E+N+S)
#s_pot.set(0) #s_pot.get()
#row=row+1

#---------------------------------------------------------------------------------------

#l_0 = Label(top, text ="----------------------")
#l_1 = Label(top, text ="----------------------")
#l_2 = Label(top, text ="----------------------")
#l_3 = Label(top, text ="----------------------")

#l_0.grid(row = row, column = 0)
#l_1.grid(row = row, column = 1)
#l_2.grid(row = row, column = 2)
#l_3.grid(row = row, column = 3)
#row = row + 1

my_canvas.bind("<Button-1>"       , callback_my_canvas_mouse_press)
my_canvas.bind("<ButtonRelease-1>", callback_my_canvas_mouse_release)
my_canvas.bind("<B1-Motion>"       , callback_my_canvas_mouse_move)
my_canvas.bind("<Button-3>"        , callback_my_canvas_mouse_press_right)
my_canvas.bind("<ButtonRelease-3>", callback_my_canvas_mouse_release_right)
top.bind("<Key>", cb_key)
top.bind("<KeyRelease>", cb_key_release)



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# MAIN
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

if(serial_ok):
    try:
        ser = serial.Serial(SZ_SERIALPORT,115200,timeout=10,stopbits=serial.STOPBITS_TWO)
        ser.setDTR(False)
        print("INFO:  Ouverture du port serie " + SZ_SERIALPORT + " OK")
    except:
        serial_ok=0
        print("ERROR: Ne peut pas ouvrir le port serie " + SZ_SERIALPORT)

#myFont = Font(family="Times New Roman", size=12)
#text.configure(font=myFont)
#myFont.configure(size=14)
draw_first()
draw_update()

# Thread on enumeration checking
daemon_bool = True
def daemon_func():
    global cpt_err
    next_call = time.time()
    while daemon_bool:
        ##print("time="+str(datetime.datetime.now())+" cpt_err="+str(cpt_err)+" x="+str(x_press)+" y="+str(y_press))
        try:
            timer_1s_cb()
            next_call += 0.1
            sleep_duration = next_call - time.time()
            if(sleep_duration <= 0):
                print("ERROR: non accurate time !!")
                cpt_err += 1
                #time.sleep(1)
                next_call = time.time()
            else:
                time.sleep(sleep_duration)
        except RuntimeError:
            None


daemon_thread = threading.Thread(target=daemon_func)
daemon_thread.daemon = True
daemon_thread.start()

top.mainloop()

if(serial_ok):
    ser.close()
daemon_bool = False
print("ByeBye")
time.sleep(1)



# QUELQUES NOTES SUR LA PWM POUR ARDUINO UNO R3:

# /*
# * T0A --> PWM D6
# * T0B --> PWM D5
# * T1A --> PWM D9
# * T1B --> PWM D10
# * T2A --> PWM D11
# * T2B --> PWM D3
# *
# * analogWrite(pin, value);  // 0->0% 1->2/256% 255->256/256%
# * T0 aussi utilise pour millis ... (pas de pb pour utiliser pwm en //)
# * T2 peut etre utilise par tone (dans ce cas pas de pwm avec T2)
# *     tone(pin,value,[duration ms])  //31Hz-65kHz
# *     notone()
# * T1 peut etre utilise par servo (dans ce cas pas de pwm avec T1) servos sur 12 pins 2-13
# *     #include <Servo.h>
# *     Servo aServo  or   Servo tServo[12]
# *     aServo.attach(pin_number)
# *     aServo.writeMicroseconds(uS) // aServo.write(0-180)
# *     plus besoin d'utiliser refresh
# */

# EXEMPLE DE CODE ARDUINO DE BASE supportant juste PWM (sens et vitesse)
# QUI FONCTIONNE AVEC CETTE CABINE:
# Pour le code plus complet avec DCC et manette, regarder le fichier cabine.ino le plus recent
#
# #define PIN_PWM  6
# #define PIN_SENS 5
#
# void setup()
# {
#    pinMode(PIN_PWM , OUTPUT); digitalWrite(PIN_PWM , LOW);
#    pinMode(PIN_SENS, OUTPUT); digitalWrite(PIN_SENS, LOW);
#
#    pinMode(13, OUTPUT);
#    digitalWrite(13, HIGH);
#    Serial.begin(115200);
#    while (!Serial) { }
#    digitalWrite(13, LOW);
# }
#
# int step=0;
# int sens;
# int pwm_vit;
#
# void loop()
# {
#     int rx;
#
#     rx = Serial.read();
#     if(rx==-1) return;
#
#     if(step==0)
#     {
#         if(rx=='s') {}
#         if(rx=='p') step=1;
#         if(rx=='0') Serial.write(analogRead(A0)/4);   //0-1023->0-255
#         if(rx=='1') Serial.write(analogRead(A1)/4);   //0-1023->0-255
#         if(rx=='e') { Serial.write(0xff); Serial.write(0xff); } //not supported
#         if(rx=='k') step=3;
#         if(rx=='d') step=4;
#     }
#     else if(step==1)
#     {
#         sens = rx;
#         step = 2;
#     }
#     else if(step==2)
#     {
#         pwm_vit = rx;
#         step = 0;
#
#         if(sens)
#             digitalWrite(PIN_SENS, HIGH);
#         else
#             digitalWrite(PIN_SENS, LOW);
#
#         analogWrite(PIN_PWM, pwm_vit);
#     }
#     else if(step==3)
#     {
#         step = 0;
#     }
#     else if(step==4)
#     {
#          step = 5;
#     }
#     else if(step==5)
#     {
#          step = 6;
#     }
#     else if(step==6)
#     {
#          step = 7;
#     }
#     else if(step==7)
#     {
#          step = 0;
#     }
# }