# GUI ptogramateur DCC
#
# History:
# 2016/12/21: Delmas-Begue Ulysse: creation
#
# Notes:
# License: GPLv2
# This application works on Linux/Windows and Python3.x/2.x
#
# TBD
#

TITLE = "FDCC DCC-PROG v20161221 UDB"
SZ_SERIALPORT = "\\\\.\\COM4"


#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# IMPORT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

import os
import time
import sys
import subprocess
import threading
import datetime
try:
    # for Python 3
    from tkinter import *
    print("Python 3.x interpreter detected")
except ImportError:
    # for Python2
    from Tkinter import *
    print("Python 2.x interpreter detected")
from math import *
import tkinter.messagebox

ser = 0
serial_ok = 1
try:
    import serial
except ImportError:
    # for Python2
    serial_ok = 0
    print("Cannot load serial lib")
    

#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# SERIEL FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

def serial_update():
    global ser;
       
    if(serial_ok==0):
        return

    #try:
    if(1):

        # 1) synchros   
        data = ord('s')
        for i in range(0,8):
            ser.write(bytes([data]))

        # 6) prog cv
        ser.write(bytes([ord('!')]))
        ser.write(bytes([0x55]))
        ser.write(bytes([0xAA]))
        dat = cv_adr >> 8 ; ser.write(bytes([dat])); #print("date="+str(dat))
        dat = cv_adr & 255; ser.write(bytes([dat])); #print("date="+str(dat))
        dat = cv_dat & 255; ser.write(bytes([dat])); #print("date="+str(dat))
        cv_prog = 0
        
        #for i in range(0,3):
        #    while(ser.inWaiting()==0):
        #        pass
        #    rb = ser.read(1)
        #    print("RXXXXX="+str(rb[0])+"\n")      
        
    #except:
    #    serial_ok=0
    #    print("ERROR: Perte de la liaison serie")
        
    return

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# CALLBACKS
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

cv_adr = 1
cv_dat = 3
    
def cv_wr_cb():
    global cv_adr; global cv_dat; global cv_prog
    #tkinter.messagebox.showerror("ATTENTION", "ATTENTION, TOUTES LES LOCOMOTIVES ALIMENTEES PAR LE BOOSTER SERONT PROGRAMEES !")
    tkinter.messagebox.showwarning("ATTENTION", "ATTENTION, TOUTES LES LOCOMOTIVES ALIMENTEES PAR LE BOOSTER SERONT PROGRAMEES !")
    cv_adr = int(e_cv_adr.get())
    cv_dat = int(e_cv_dat.get())
    serial_update()
    return

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# GUI management
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

top = Tk()  
top.title(TITLE)

row = 0

l_cv     = Label(top, text = "CV (adr, dat)") #font=("Helvetica", 16), fg = "#800000")
e_cv_adr = Entry(top)
e_cv_dat = Entry(top)
b_cv_wr  = Button(top, text = "WR", command = cv_wr_cb)
l_cv.grid(row = row, column = 0, sticky = W + E + N + S)
e_cv_adr.grid(row = row, column = 1, sticky = W + E + N + S)
e_cv_dat.grid(row = row, column = 2, sticky = W + E + N + S)
b_cv_wr.grid(row = row, column = 3, sticky = W + E + N + S)
e_cv_adr.delete(0, 1000); e_cv_adr.insert(0, "1")
e_cv_dat.delete(0, 1000); e_cv_dat.insert(0, "3")
row=row+1


#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# MAIN
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

try:
    ser = serial.Serial(SZ_SERIALPORT,115200,timeout=10,stopbits=serial.STOPBITS_TWO) 
    ser.setDTR(False)
except:
    serial_ok=0
    print("Cannot open serial port")
    
top.mainloop()

if(serial_ok):
    ser.close()
daemon_bool = False
print("ByeBye")
time.sleep(1)
