# MiniCab : GUI du testeur DCC
#
# History:
# 2016/12/21: Delmas-Begue Ulysse: creation
#
# Notes:
# License: GPLv2
# This application works on Linux/Windows and Python3.x/2.x
#
# TBD
#

TITLE = "MINI-CAB DCC TEST v20161221 UDB"
SZ_SERIALPORT = "\\\\.\\COM4"


#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# IMPORT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

import os
import time
import sys
import subprocess
import threading
import datetime
try:
    # for Python 3
    from tkinter import *
    print("Python 3.x interpreter detected")
except ImportError:
    # for Python2
    from Tkinter import *
    print("Python 2.x interpreter detected")
from math import *
import tkinter.messagebox

ser = 0
serial_ok = 1
try:
    import serial
except ImportError:
    # for Python2
    serial_ok = 0
    print("Cannot load serial lib")
    

#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# SERIEL FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

sens = 1  #1=AV, 0=AR
cran_0_28 = 0
dcc_adr = 3
fct_43210 = 0

def serial_update():
    global ser;

    adr_cb(); print("adr="+str(dcc_adr)+"\n")
    
    if(serial_ok==0):
        return

    #try:
    if(1):

        # 1) synchros   
        data = ord('s')
        for i in range(0,8):
            ser.write(bytes([data]))

       # 3) dcc command (adr + sens + vit + fct)
        ser.write(bytes([ord('d')]))
        #adresse
        ser.write(bytes([dcc_adr]))
        #sens
        ser.write(bytes([sens]))
        #vit
        ser.write(bytes([cran_0_28]))
        # fct (F0 si le bouton signalisation est actif)      
        ser.write(bytes([fct_43210]))     
        
    #except:
    #    serial_ok=0
    #    print("ERROR: Perte de la liaison serie")
        
    return

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# CALLBACKS
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
    
def sens_cb():
    global sens
    global c_sens
    if(sens == 1):
        sens = 0; c_sens.deselect()
    else:
        sens = 1; c_sens.select()
    serial_update()
    print("sens="+str(sens)+"\n")
    return
    
def pot_cb(val):
    global cran_0_28
    global s_pot
    cran_0_28 = int(s_pot.get())
    serial_update()
    print("cran_0_28="+str(cran_0_28)+"\n")  #or val
    return

def f0_cb():
    global fct_43210
    global c_f0
    if(fct_43210&1):
        fct_43210 ^= 1; c_f0.deselect()
    else:
        fct_43210 ^= 1; c_f0.select()
    serial_update()
    print("fct_43210="+str(fct_43210)+"\n")
    return

def f1_cb():
    global fct_43210
    global c_f1
    if(fct_43210&2):
        fct_43210 ^= 2; c_f1.deselect()
    else:
        fct_43210 ^= 2; c_f1.select()
    serial_update()
    print("fct_43210="+str(fct_43210)+"\n")
    return

def f2_cb():
    global fct_43210
    global c_f2
    if(fct_43210&4):
        fct_43210 ^= 4; c_f2.deselect()
    else:
        fct_43210 ^= 4; c_f2.select()
    serial_update()
    print("fct_43210="+str(fct_43210)+"\n")
    return

def f3_cb():
    global fct_43210
    global c_f3
    if(fct_43210&8):
        fct_43210 ^= 8; c_f3.deselect()
    else:
        fct_43210 ^= 8; c_f3.select()
    serial_update()
    print("fct_43210="+str(fct_43210)+"\n")
    return
    
def f4_cb():
    global fct_43210
    global c_f4
    if(fct_43210&16):
        fct_43210 ^= 16; c_f4.deselect()
    else:
        fct_43210 ^= 16; c_f4.select()
    serial_update()
    print("fct_43210="+str(fct_43210)+"\n")
    return
    
def adr_cb():
    global dcc_adr
    s = e_adr.get()
    try:
        a = int(s)
    except:
        a = 0
    dcc_adr = a 

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# GUI management
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

top = Tk()  
top.title(TITLE)

row = 0

l_adr = Label(top, text = "adr") #font=("Helvetica", 16), fg = "#800000")
e_adr = Entry(top)
l_adr.grid(row = row, column = 0, sticky = W)
e_adr.grid(row = row, column = 1, sticky = W + E + N + S)
e_adr.delete(0, 1000); e_adr.insert(0, "3")

row += 1

c_sens = tkinter.Checkbutton(top, text="sens AV", command = sens_cb)
c_sens.grid(row = row, column = 0, sticky = W)
c_sens.select()

#s_pot = Scale(top, from_=0, to=28, orient=VERTICAL, tickinterval=5, command = pot_cb, length=200)
#s_pot.grid(row = 0, column = 1, rowspan=6, sticky = W + E + N + S)
s_pot = Scale(top, from_=0, to=28, orient=HORIZONTAL, tickinterval=5, command = pot_cb, length=200)
s_pot.grid(row = row, column = 1, sticky = W + E + N + S)
s_pot.set(0)

row += 1

c_f0 = tkinter.Checkbutton(top, text="sens F0/FL", command = f0_cb)
c_f0.grid(row = row, column = 0, sticky = W)
c_f0.deselect()
row += 1
c_f1 = tkinter.Checkbutton(top, text="sens F1", command = f1_cb)
c_f1.grid(row = row, column = 0, sticky = W)
c_f1.deselect()
row += 1
c_f2 = tkinter.Checkbutton(top, text="sens F2", command = f2_cb)
c_f2.grid(row = row, column = 0, sticky = W)
c_f2.deselect()
row += 1
c_f3 = tkinter.Checkbutton(top, text="sens F3", command = f3_cb)
c_f3.grid(row = row, column = 0, sticky = W)
c_f3.deselect()
row += 1
c_f4 = tkinter.Checkbutton(top, text="sens F4", command = f4_cb)
c_f4.grid(row = row, column = 0, sticky = W)
c_f4.deselect()



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# MAIN
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

try:
    ser = serial.Serial(SZ_SERIALPORT,115200,timeout=10,stopbits=serial.STOPBITS_TWO) 
    ser.setDTR(False)
except:
    serial_ok=0
    print("Cannot open serial port")
    
top.mainloop()

if(serial_ok):
    ser.close()
daemon_bool = False
print("ByeBye")
time.sleep(1)
