# MiniCab : GUI du testeur PWM
#
# History:
# 2016/12/21: Delmas-Begue Ulysse: creation
#
# Notes:
# License: GPLv2
# This application works on Linux/Windows and Python3.x/2.x
#
# TBD
#

TITLE = "MINI-CAB PWM TEST v20161221 UDB"
SZ_SERIALPORT = "\\\\.\\COM4"


#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# IMPORT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

import os
import time
import sys
import subprocess
import threading
import datetime
try:
    # for Python 3
    from tkinter import *
    print("Python 3.x interpreter detected")
except ImportError:
    # for Python2
    from Tkinter import *
    print("Python 2.x interpreter detected")
from math import *
import tkinter.messagebox

ser = 0
serial_ok = 1
try:
    import serial
except ImportError:
    # for Python2
    serial_ok = 0
    print("Cannot load serial lib")
    

#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# SERIEL FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

sens = 1  #1=AV, 0=AR
pwm_0_255 = 0

def serial_update():
    global ser;
       
    if(serial_ok==0):
        return

    #try:
    if(1):

        # 1) synchros   
        data = ord('s')
        for i in range(0,8):
            ser.write(bytes([data]))

        # 2) pwm command (sens + vit)
        ser.write(bytes([ord('p')]))
        #sens
        ser.write(bytes([sens]))
        #vit
        ser.write(bytes([pwm_0_255]))
        
        #for i in range(0,3):
        #    while(ser.inWaiting()==0):
        #        pass
        #    rb = ser.read(1)
        #    print("RXXXXX="+str(rb[0])+"\n")      
        
    #except:
    #    serial_ok=0
    #    print("ERROR: Perte de la liaison serie")
        
    return

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# CALLBACKS
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
    
def sens_cb():
    global sens
    global c_sens
    if(sens == 1):
        sens = 0; c_sens.deselect()
    else:
        sens = 1; c_sens.select()
    serial_update()
    print("sens="+str(sens)+"\n")
    return
    
def pot_cb(val):
    global pwm_0_255
    global s_pot
    pwm_0_255 = int(s_pot.get())
    serial_update()
    print("pwm_0_255="+str(pwm_0_255)+"\n")  #or val
    return

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# GUI management
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

top = Tk()  
top.title(TITLE)

row = 0

c_sens = tkinter.Checkbutton(top, text="sens AV", command = sens_cb)
c_sens.grid(row = row, column = 0, sticky = W + E + N + S)
c_sens.select()

s_pot = Scale(top, from_=0, to=255, orient=HORIZONTAL, tickinterval=50, command = pot_cb, length=200)
s_pot.grid(row = row, column = 1, sticky = W + E + N + S)
s_pot.set(0)



#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# MAIN
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

try:
    ser = serial.Serial(SZ_SERIALPORT,115200,timeout=10,stopbits=serial.STOPBITS_TWO) 
    ser.setDTR(False)
except:
    serial_ok=0
    print("Cannot open serial port")
    
top.mainloop()

if(serial_ok):
    ser.close()
daemon_bool = False
print("ByeBye")
time.sleep(1)
